package de.desy.mst.common.util.autoclient;

import de.desy.mst.libs.util.helper.ADeveloper;
import de.desy.mst.libs.util.helper.AVersion;
import de.desy.mst.libs.util.helper.CHelperLib;
import de.desy.mst.libs.util.helper.Version;
import de.desy.mst.libs.util.helper.ui.version.UIVersion;
import de.desy.tine.startup.TInitializerFactory;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.net.URL;
import javax.swing.Box;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.SwingUtilities;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Main functionality called on executing this application.
 * 
 * @author herb
 * @author <a href="marcus(dot)walla(at)desy(dot)de">walla</a>
 * @version $Id: Autoclient.java 73838 2016-11-16 08:45:13Z walla $
 */
@AVersion(
		application = "Autoclient: PC104 Server File Transfer Tool", major = 1, minor = 2, revision = 0, buildId = "$Revision: 73838 $", releaseDate = "2016/11/16",
		developers = {
		 	  @ADeveloper(email = "marcus.walla[at]desy[dot]de", fullName = "Marcus Walla", group = "MCS 1", phone = "2628", room = "30/506")
		}
	)
public class Autoclient extends javax.swing.JFrame {
	
	private static final long serialVersionUID = 1004442170202355260L;
	private static final Version version = new Version(Autoclient.class);
	
	ClientPanel clientPanel;
	  
	public static void main(String args[]) {
		SwingUtilities.invokeLater(new Runnable() {
			@Override public void run() {
				new Autoclient().setVisible(true);
			}
		});
    }
	    private JMenuItem createVersionMenu() 
    {
        final String tineVersion = TInitializerFactory.getInstance().getInitializer().getVersion() + " [build ID: " + TInitializerFactory.getInstance().getInitializer().getBuildId() + "]";
		final JDialog dialogVersionInfo = UIVersion.createVersionDialog(this, tineVersion, getVersion(), CHelperLib.getVersion());
		final JMenuItem menuItemVersionInfo = new JMenuItem();
		menuItemVersionInfo.setText(UIVersion.MENU_ITEM_INFO);
		menuItemVersionInfo.addActionListener((final ActionEvent event) -> {
            dialogVersionInfo.setVisible(true);
        });

		return menuItemVersionInfo;
	}


	private static Version getVersion() { return Autoclient.version; }
	  
	public Autoclient() {
		initialize(); 
	}
  
	void initialize() {
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);    
	    this.setTitle(getVersion().application() + " - Version: " + getVersion().toString());
	    
		final URL url = getClass().getResource("/resources/webstart/Autoclient.png");
		final Image image = Toolkit.getDefaultToolkit().getImage(url);
		this.setIconImage(image);
		
	    final JMenuBar menuBar = new JMenuBar();
	    this.setJMenuBar(menuBar);
	    
	    final JMenu menuHilfe = new JMenu("Hilfe");
	    menuHilfe.add(createVersionMenu());
	    
	    menuBar.add(Box.createHorizontalGlue());
	    menuBar.add(menuHilfe);
		
	    clientPanel = new ClientPanel();  
	    this.add(clientPanel);
	    this.pack();
	}
}
/* end of file */