/**
 * File: Counter.java
 * Date: Mar 31, 2010
 */
package de.desy.mst.libs.accelerator;

import de.desy.mst.libs.accelerator.exception.NotImplementedException;

/**
 * Global counter class which includes indirect increments the internal counter.
 * If the counter is bigger then the before set value the method of {@link #isFinished()}
 * returns {@code true} otherwise {@code false}. To increment the counter you
 * should call {@link #increment()}, which also returns when the counter exceeds 
 * its limit.
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: Counter.java 53955 2013-02-25 15:47:32Z walla $
 * @deprecated Use class {@link CounterGlobal} instead.
 */
@Deprecated
public final class Counter {
	// --- CLASS METHODS -------------------------------------------------------
	/**
	 * Resets the counter to 1 and the limit to 3. 
	 * @see #reset(int)
	 * @deprecated Use method {@link CounterGlobal#reset()} instead.
	 */
	@Deprecated
	public static final void reset() { CounterGlobal.reset(); }
	
	/**
	 * Resets the counter to 1 and sets the limit accordingly to the depended
	 * limit value. The limit must be greater then 1 otherwise an 
	 * {@link IllegalArgumentException} is thrown.
	 * @param limit_ Upper limit value.
	 * @deprecated functionality is deprecated and should never be used! Use {@link CounterGlobal#reset()} instead.
	 */
	@Deprecated
	public static final void reset(final int limit_) { throw new NotImplementedException("functionality is deprecated and should never be used! Use reset() instead."); }
	
	/**
	 * Increments the counter. The counter is not incremented if the counter
	 * exceeds its limit.
	 * @return Returns if the counter exceeds limit a {@code true} otherwise {@code false}.
	 * @deprecated Use method {@link CounterGlobal#increment()} instead.
	 */
	@Deprecated
	public static final boolean increment() { return CounterGlobal.increment(); }

	/**
	 * Returns {@code true} if the counter exceeds its limit otherwise
	 * {@code false}. The counter is not manipulated by this method.
	 * @return Depending on the relationship between the limit and counter the
	 * 		corresponding boolean value is returned. 
	 * @deprecated Use method {@link CounterGlobal#isFinished()} instead.
	 */
	@Deprecated
	public static final boolean isFinished() { return CounterGlobal.isFinished(); }
}
/* end of file */