/*
 *
 * File: EServers.java
 * Date: Nov 14, 2007; 2:01:07 PM
 */
package de.desy.mst.libs.accelerator;

/**
 * This enumeration stores all relevant values of the servers which the
 * developer will respond to. This can be one off ...
 * 
 * <table cellspacing="2" cellpadding="4">
 * <tr><th>Enumeration</th><th>Description</th></tr>
 * <tr bgcolor="#A0A0A0"><td>{@link #CDI}</td><td>CDI hardware server.</td></tr>
 * <tr bgcolor="#E0E0E0"><td>{@link #TINE}</td><td>A normal TINE middle layer server.</td></tr>
 * <tr bgcolor="#A0A0A0"><td>{@link #EVENTARCHIVE}</td><td>Event archive server (this is currently not used).</td></tr>
 * </table>
 * 
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: EServer.java 32041 2010-01-07 13:18:25Z walla $
 */
public enum EServer
{
	/** The CDI server. */
	CDI, 
	
	/** The device server. */
	TINE, 
	
	/** The event server. */
	EVENTARCHIVE;
}
/* end of file */