/*
 *
 * File: IEDataMpxChannel.java
 * Creation date: May 30, 2008 - 3:00:44 PM
 */
package de.desy.mst.libs.accelerator;

import de.desy.mst.libs.accelerator.exception.IllegalChannelException;

/**
 * This interface cares about the multiplexer channel value and distributes the
 * getter and setter methods.
 * 
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: IEDataMpxChannel.java 12126 2008-05-30 16:42:25Z walla $
 */
public interface IEDataMpxChannel
{
	/**
	 * Returns the multiplexer channel value.
	 * 
	 * @return Returns the channel value.
	 */
	public abstract int getChannel();
	
	/**
	 * Sets the multiplexer channel value.
	 *  
	 * @param channel_ Multiplexer channel.
	 */
	public abstract void setChannel(final int channel_) 
		throws IllegalChannelException;
}
/* end of file */