/*
 *
 * File: IEDevice.java
 * Date: Mar 27, 2007; 2:31:18 PM
 */
package de.desy.mst.libs.accelerator;

import de.desy.mst.libs.accelerator.model.ICDIDevice;


/**
 * <p>These enumeration interface represents each device on its own. So each entry
 * in this interface is only ONE software device in the real hardware.</p>
 * 
 * @author <a href="marcus.walla(at)desy.de">walla</a>
 * @version $Id: IEDevice.java 12066 2008-05-29 08:35:57Z walla $
 *
 */
public interface IEDevice extends IEEnum
{
	
	/**
	 * Returns the TINE data format (or better data type) of the current device 
	 * name.
	 *  
	 * @return The TINE data format is returned.
	 */
	public abstract short dataType();

	/**
	 * Returns the current TINE delay for this device.
	 * 
	 * @return Returns the delay as an integer value.
	 */
	public abstract int delay();
	
	/**
	 * Returns the CDI device.
	 *  
	 * @return Returns the CDI device.
	 */
	public abstract ICDIDevice cdiDevice();
}
/* end of file */