/*
 *
 * File: IRunnable.java
 * Date: Sep 10, 2007; 5:05:48 PM
 */
package de.desy.mst.libs.accelerator;


/**
 * This is the runnable interface of the corresponding thread. In this class
 * there are more signatures of different methods which help one to suggest
 * the state of the thread and set its value.
 *  
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: IRunnable.java 12066 2008-05-29 08:35:57Z walla $
 */
public interface IRunnable extends Runnable
{
	
	/**
	 * Queries if this thread is active or not.
	 * 
	 * @return A boolean value is returned, which provides the activeness of this 
	 * 		thread.
	 */
	public abstract boolean isActive();
	
}
/* end of file */
