package de.desy.mst.libs.accelerator;

import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * ATTENTION: THIS CLASS IS DEPRECATED. INSTEAD USE THE CLASS {@link LogProvider}!
 * <p>
 * Helper framework for Java logger instances. Implements getter functions for 
 * fetching a logger instance depending on the specified class. A normal user 
 * will mostly call the {@link #getLogger(Class)} method to retrieve a logger 
 * instance.
 * 
 * <p>
 * 
 * If the log is also written to a file by defining the method argument of 
 * {@code isStorable} then all logging is persistently stored on the mounted 
 * drive. The drive depends on the OS:
 * <ul>
 * <li>On WINDOWS systems it always uses the root drive L and the log directory</li>
 * <li>On UNIX systems it always uses the folder /var/tmp/log</li>
 * </ul>
 * Underneath this root folder the main class name is taken to log the messages.
 * Therefore you should always call a first logger in the main class because
 * from its class name the file is build. See also below.
 * 
 * <p>  
 * 
 * Per default a flag for the MSTApp logger is set to {@code false} and can be specified by
 * calling one of both methods {@link #getLogger(Class, Level, boolean)} and
 * {@link #getLogger(Class, Level, boolean, boolean, boolean)}
 * 
 * <p>
 * 
 * <b>NOTE:</b> Never use the method {@link #setLogFilename(String)}! The file name is filter from the
 * concrete package and main class name instance from its first call to {@link #getLogger(Class)}.
 * So you should always create one logger in the main class to clarify
 * the file name. If you do create a logger at a later stage in some
 * other class or in a sub-package the file name will change to the concrete
 * first calling class instance. This can result in unexpected file names. The
 * log file tries to find the corresponding log directory on windows drive L. If
 * it doesn't exist it will create one. In this directory the project name for
 * the class package name is filter to a directory name. 
 * 
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: LoggerImpl.java 56033 2013-07-30 16:01:42Z walla $
 */
@Deprecated
public final class LoggerImpl {
	// --- CLASS INSTANCES -----------------------------------------------------
	@Deprecated
	public static final boolean DEFAULT_TIME_AND_DATE	= false;
	@Deprecated
	public static final String LOG_DIRECTORY            = "log";

	// --- CLASS INITIALIZATION ------------------------------------------------
	// --- ENUMERATION ---------------------------------------------------------
	@Deprecated
	public enum ELoggingProperty {
		@Deprecated
		MCS_LOGGING,
		
		/** 
		 * Reflects if the logging information is stored in a 
		 * separate file. The files are rotated. You can specify the log
		 * filename with the method {@link #setLogFilename(String)}. 
		 * As a suffix of the filename a number from 1 to 10 represents older 
		 * log filenames. 
		 * The size of a file is 1000000 bytes.
		 */
		@Deprecated
		FILE_STORAGE
	}
	
	// --- CLASS METHODS -------------------------------------------------------
	// Note: only for compatibility ...
	private static LogProvider.ELoggingProperty transform(LoggerImpl.ELoggingProperty property) {
		switch(property) {
		case FILE_STORAGE:
			return LogProvider.ELoggingProperty.FILE_STORAGE;
		case MCS_LOGGING:
			return LogProvider.ELoggingProperty.MCS_LOGGING;
		default:
			return null;
		}
	}
	
	// --- CONSTRUCTOR ---------------------------------------------------------
	@Deprecated
	private LoggerImpl() {}
	
	// --- CLASS METHODS -------------------------------------------------------
	/**
	 * Creates the current Java logger instance of the specified class. For
	 * more information you should have a look at {@link #getLogger(Class, Level)}.
	 * The default log level is set to {@code Level.INFO}. The logging is stored
	 * in a file.
	 * @param clazz Logging class instance.
	 * @return returns an instance of the log classes.
	 * @deprecated Use {@link #getLogger(Class)} instead.
	 */
	@Deprecated
	public static Logger createLogger(final Class<?> clazz) {
		return LogProvider.getLogger(clazz, Level.INFO, null, DEFAULT_TIME_AND_DATE);
	}
	
	/**
	 * Creates the current Java logger instance of the specified class. For
	 * more information you should have a look at {@link #getLogger(Class, Level)}.
	 * The default log level is set to {@code Level.INFO}. The logging is stored
	 * in a file.
	 * @param clazz Logging class instance.
	 * @return returns an instance of the log classes.
	 */
	@Deprecated
	public static Logger getLogger(final Class<?> clazz) {
		return LogProvider.getLogger(clazz, Level.INFO, null, DEFAULT_TIME_AND_DATE);
	}
	
	/**
	 * Gets the current Java logger instance of the specified class and level. For
	 * more information you should have a look at {@link #getLogger(Class, Level, boolean, boolean)}.
	 * The default log level is set to {@code Level.INFO}. The logging is stored
	 * in a file.
	 * @param clazz Logging class instance.
	 * @param level Log level.
	 * @return returns an instance of the log classes.
	 * @deprecated Use {@link #getLogger(Class, Level)} instead.
	 */
	@Deprecated
	public static Logger createLogger(final Class<?> clazz, final Level level) {
		return LogProvider.getLogger(clazz, level, null, DEFAULT_TIME_AND_DATE);
	}
	
	/**
	 * Gets the current Java logger instance of the specified class and level. For
	 * more information you should have a look at {@link #getLogger(Class, Level, boolean, boolean)}.
	 * The default log level is set to {@code Level.INFO}. The logging is stored
	 * in a file and only a timestamp is printed.
	 * @param clazz Logging class instance.
	 * @param level Log level.
	 * @return returns an instance of the log classes.
	 */
	@Deprecated
	public static Logger getLogger(final Class<?> clazz, final Level level) {
		return LogProvider.getLogger(clazz, level, null, DEFAULT_TIME_AND_DATE);
	}
	
	/**
	 * Gets the current Java logger instance of the specified class and level. For
	 * more information you should have a look at {@link #getLogger(Class, Level, boolean, boolean)}.
	 * The default log level is set to {@code Level.INFO}. The logging is stored
	 * in a file and only a timestamp is printed.
	 * @param clazz Logging class instance.
	 * @param level Log level.
	 * @param allowsMCSLogging Specifies if beside the normal console logger also
	 * 		the MSTApp logger is used.
	 * @return returns an instance of the log classes.
	 */
	@Deprecated
	public static Logger getLogger(final Class<?> clazz, final Level level, ELoggingProperty property) {
		return LogProvider.getLogger(clazz, level, transform(property), LogProvider.DEFAULT_TIME_AND_DATE);
	}
	
	/**
	 * Gets the current Java logger instance of the specified class. The
	 * log messages are stored in a persistent file. The file name can be 
	 * set via {@link #setLogFilename(String)}. For ore information you should 
	 * have a look at {@link #getLogger(Class, Level, boolean, boolean)}.
	 * The default log level is set to {@code Level.INFO} and only a timestamp
	 * is printed.
	 * @param clazz Logging class instance.
	 * @param isStorable Reflects if the logging information is stored in a 
	 * 		separate file. The files are rotated. You can specify the log
	 * 		filename with the method {@link #setLogFilename(String)}. 
	 * 		As a suffix of the filename a number from 1 to 10 represents older 
	 * 		log filenames. 
	 * 		The size of a file is 1000000 bytes.
	 * @return returns an instance of the log classes.
	 * @deprecated Use method {@link @getLogger(Class, boolean)} instead.
	 */
	@Deprecated
	public static Logger createLogger(final Class<?> clazz, final boolean isStorable) {
		return LogProvider.getLogger(clazz, Level.INFO, isStorable ? transform(ELoggingProperty.FILE_STORAGE) : null, DEFAULT_TIME_AND_DATE);
	}
	
	/**
	 * Gets the current Java logger instance of the specified class. The
	 * log messages are stored in a persistent file. The file name can be 
	 * set via {@link #setLogFilename(String)}. For more information you should 
	 * have a look at {@link #getLogger(Class, Level, boolean, boolean)}.
	 * The default log level is set to {@code Level.INFO} and only a timestamp
	 * is printed.
	 * @param clazz Logging class instance.
	 * @param isStorable Reflects if the logging information is stored in a 
	 * 		separate file. The files are rotated. You can specify the log
	 * 		filename with the method {@link #setLogFilename(String)}. 
	 * 		As a suffix of the filename a number from 1 to 10 represents older 
	 * 		log filenames. 
	 * 		The size of a file is 1000000 bytes.
	 * @return returns an instance of the log classes.
	 * @return New created logger instance.
	 */
	@Deprecated
	public static Logger getLogger(final Class<?> clazz, final ELoggingProperty property) {
		return LoggerImpl.getLogger(clazz, Level.INFO, property, DEFAULT_TIME_AND_DATE);
	}
	
	/**
	 * Gets the current Java logger instance of the specified class and
	 * a level which is specified with its log level. 
	 * A logger instance can be created via the following skeleton:
	 * <pre>
public class A {
    private static final Logger log = LoggerImpl.getLogger(A.class);
    ...
    void abc() {
        log.info("only a comment...");
    }
}
	   </pre>
	 * You can influence the behavior of the logger with a property 
	 * file. This file must contain valid key-value-pairs for controlling
	 * the behavior of the logger. For more information about the file see at 
	 * <a href="http://de.wikibooks.org/wiki/Java_Standard:_Logging_API_von_Java">Wikibooks (DE)</a> web page. 
	 * One example property file is included in the root folder
	 * {@code examples} under {@code log/mpsdiag.properties}.
	 * This can easily be set via the command line argument of 
	 * {@code -Djava.util.logging.config.file=}<i>/path/to/app.properties</i>.
	 * <p>
	 * Moreover you can also specify the log filename with the method {@link #setLogFilename(String)}.
	 * @param clazz Logging class instance.
	 * @param level Log level.
	 * @param isStorable Reflects if the logging information is stored in a 
 	 * 		separate file. The files are rotated. You can specify the log
 	 * 		filename with the method {@link #setLogFilename(String)}. 
 	 * 		As a suffix of the filename a number from 1 to 10 represents older 
 	 * 		log filenames. 
 	 * 		The size of a file is 1000000 bytes.
 	 * @param hasDateFormat Specifies if the logging message only includes the 
	 * 		time (false) or time with date (true).
	 * @return returns an instance of the log classes.
	 * @deprecated Use {@link #getLogger(Class, Level, boolean, boolean)} instead.
	 */
	@Deprecated
	public static Logger createLogger(final Class<?> clazz, final Level level, final boolean isStorable, final boolean hasDateFormat) {
		return getLogger(clazz, level, isStorable ? ELoggingProperty.FILE_STORAGE : null, hasDateFormat);
	}
	
	/**
	 * Gets the current Java logger instance of the specified class and
	 * a level which is specified with its log level. 
	 * A logger instance can be created via the following skeleton:
	 * <pre>
public class A {
    private static final Logger log = LoggerImpl.getLogger(A.class);
    ...
    void abc() {
        log.info("only a comment...");
    }
}
	   </pre>
	 * You can influence the behavior of the logger with a property 
	 * file. This file must contain valid key-value-pairs for controlling
	 * the behavior of the logger. For more information about the file see at 
	 * <a href="http://de.wikibooks.org/wiki/Java_Standard:_Logging_API_von_Java">Wikibooks (DE)</a> web page. 
	 * One example property file is included in the root folder
	 * {@code examples} under {@code log/mpsdiag.properties}.
	 * This can easily be set via the command line argument of 
	 * {@code -Djava.util.logging.config.file=}<i>/path/to/app.properties</i>.
	 * <p>
	 * Moreover you can also specify the log filename with the method {@link #setLogFilename(String)}.
	 * @param clazz Logging class instance.
	 * @param level Log level.
	 * @param property Specifies the logging property used for the returned instance.
	 * @param hasDateFormat Specifies if the logging message only includes the 
	 * 		time (false) or time with date (true).
	 * @return returns an instance of the log classes.
	 */
	@Deprecated
	public static Logger getLogger(final Class<?> clazz, final Level level, final ELoggingProperty property, final boolean hasDateFormat) {
		return LogProvider.getLogger(clazz, level, transform(property), hasDateFormat);
	}
}
/* end of file */