/*
 *
 * File: EnumerationNotFoundException.java
 * Date: Apr 19, 2007; 1:31:38 PM
 */
package de.desy.mst.libs.accelerator.exception;

import de.desy.mst.libs.accelerator.IEData;

/**
 * This exception will be thrown if the composition between the CDI hardware
 * device element has no corresponding enumeration element or the enumeration
 * element is basically not found.
 * 
 * @author <a href="marcus.walla at desy.de">walla</a>
 * @version $Id: EnumerationNotFoundException.java 13841 2008-07-16 10:59:14Z walla $
 */
public class EnumerationNotFoundException extends EnumerationException
{
	/** Is the unique serial version UID */
	public final static long serialVersionUID = 6394910205043554136l;

	/**
	 * The constructor of this exception.
	 */
	public EnumerationNotFoundException()
	{
		super();
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param message_ Sets the message as its description.
	 */	public EnumerationNotFoundException(final String message_)
	{
		super(message_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public EnumerationNotFoundException(final Throwable cause_)
	{
		super(cause_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param message_ Sets the message as its description.
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public EnumerationNotFoundException(final String message_, 
			final Throwable cause_)
	{
		super(message_, cause_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param data_ The data element on which this exception occurred.
	 */
	public EnumerationNotFoundException(final IEData data_)
	{
		super(data_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param data_ The data element on which this exception occurred.
	 * @param message_ Sets the message as its description.
	 */	public EnumerationNotFoundException(final IEData data_, 
			 final String message_)
	{
		super(data_, message_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param data_ The data element on which this exception occurred.
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public EnumerationNotFoundException(final IEData data_, 
			final Throwable cause_)
	{
		super(data_, cause_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param data_ The data element on which this exception occurred.
	 * @param message_ Sets the message as its description.
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public EnumerationNotFoundException(final IEData data_, final String message_, 
			final Throwable cause_)
	{
		super(data_, message_, cause_);
	}
}
/* end of file */