/*
 *
 * File: MissingEnumerationException.java
 * Date: Nov 22, 2006; 6:02:42 PM
 */
package de.desy.mst.libs.accelerator.exception;

import de.desy.mst.libs.accelerator.IEEnum;

/**
 * The enumeration is missing one element or the element you parameterized in
 * your argument list of your method has no responding statements. For example
 * in a {@code switch-case} selection it reaches the {@code default} keyword and
 * therefore this exception is thrown.
 *
 * @author <a href="marcus.walla at desy.de">walla</a>
 * @version $Id: MissingEnumerationException.java 18322 2008-11-07 11:32:57Z walla $
 */
public class MissingEnumerationException extends EnumerationException
{
	/** Is the serial version UID to unify this class. */
	static final long serialVersionUID = 3940064943202346069l;

	/**
	 * The constructor of this exception.
	 */
	public MissingEnumerationException()
	{
	}

	/**
	 * The constructor of this exception.
	 *
	 * @param message_ The message.
	 */
	public MissingEnumerationException(final String message_)
	{
		super(message_);
	}

	/**
	 * The constructor of this exception.
	 *
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public MissingEnumerationException(final Throwable cause_)
	{
		super(cause_);
	}

	/**
	 * The constructor of this exception.
	 *
	 * @param message_ Is the message.
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public MissingEnumerationException(final String message_,
			final Throwable cause_)
	{
		super(message_, cause_);
	}

	/**
	 * The constructor of this exception.
	 *
	 * @param data_ The data element on which this exception occurred.
	 */
	public MissingEnumerationException(final IEEnum data_)
	{
		super(data_);
	}

	/**
	 * The constructor of this exception.
	 *
	 * @param data_ The data element on which this exception occurred.
	 * @param message_ The message.
	 */
	public MissingEnumerationException(final IEEnum data_,
			final String message_)
	{
		super(data_, message_);
	}

	/**
	 * The constructor of this exception.
	 *
	 * @param data_ The data element on which this exception occurred.
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public MissingEnumerationException(final IEEnum data_,
			final Throwable cause_)
	{
		super(data_, cause_);
	}

	/**
	 * The constructor of this exception.
	 *
	 * @param data_ The data element on which this exception occurred.
	 * @param message_ Is the message.
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public MissingEnumerationException(final IEEnum data_, String message_,
			Throwable cause_)
	{
		super(data_, message_, cause_);
	}
}
/* end of file */