/**
 * File: PermissionDeniedException.java
 * Date: Aug 7, 2013
 */
package de.desy.mst.libs.accelerator.exception;

import java.io.IOException;

/**
 * Connection to the specified device is not permitted.
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: PermissionDeniedException.java 56202 2013-08-07 16:36:32Z walla $
 */
public class PermissionDeniedException extends IOException {
	private static final long serialVersionUID = 6761218532318647607L;

	// --- CONSTRUCTOR ---------------------------------------------------------
	/**
	 * Constructor of permission denied exception.
	 */
	public PermissionDeniedException() {
		super();
	}

	/**
	 * Constructor of permission denied exception.
	 * @param message Message of the exception.
	 */
	public PermissionDeniedException(final String message) {
		super(message);
	}

	/**
	 * Constructor of permission denied exception.
	 * @param cause Cause of the exception.
	 */
	public PermissionDeniedException(final Throwable cause) {
		super(cause);
	}

	/**
	 * Constructor of permission denied exception.
	 * @param message Message of the exception.
	 * @param cause Cause of the exception.
	 */
	public PermissionDeniedException(final String message, final Throwable cause) {
		super(message, cause);
	}
}
/* end of file */