/*
 *
 * File: DESYFormatter.java
 * Date: Oct 5, 2006; 3:31:55 PM
 */
package de.desy.mst.libs.accelerator.logging;

import java.util.logging.Formatter;
import java.util.logging.LogRecord;
import java.util.Date;

/**
 * Is the logging formatter. It allows in contrast to the normal console handler
 * (which outputs two lines per message) to output a message in <b>ONE</b> line.
 *
 * @author <a href="marcus.walla at desy.de">walla</a>
 * @version $Id: DESYFormatter.java 53954 2013-02-25 15:44:16Z walla $
 * @deprecated Use class {@link LoggerImpl} instead.
 */
@Deprecated
public final class DESYFormatter extends Formatter
{	
	/**
	 * Is the default constructor of this class.
	 */
	@Deprecated
	public DESYFormatter()
	{
		super();
	}

	/*
	 * It will format and output the string value of a given message which is
	 * stored in the argument of {@code LogRecord}.
	 *  (non-Javadoc)
	 * @see java.util.logging.Formatter#format(java.util.logging.LogRecord)
	 */
	@Override
	@Deprecated
	public String format(LogRecord record_)
	{
		StringBuffer buffer = new StringBuffer();
		buffer.append(record_.getLevel().getName());
		buffer.append(" - ");
		buffer.append(new Date(record_.getMillis()).toString());
		buffer.append(" - ");
		if (record_.getSourceClassName() != null && record_.getSourceMethodName() != null)
		{
			buffer.append(record_.getSourceClassName().substring(record_
					.getSourceClassName().lastIndexOf('.') + 1) 
					+ '.' + record_.getSourceMethodName());
			buffer.append(" - ");
		}
		buffer.append(record_.getMessage());
		if (record_.getThrown() != null)
		{
			buffer.append(" - exception:\n");
			buffer.append('\t' + record_.getThrown().getMessage());
		}
		buffer.append('\n');
		
		return buffer.toString();
	}
}
/* end of file */