/*
 *
 * File: IExecuteFlag.java
 * Date: Dec 1, 2006; 11:05:13 AM
 */
package de.desy.mst.libs.accelerator.model;

import java.util.Collection;

import de.desy.mst.libs.accelerator.IEFlag;
import de.desy.tine.types.TCompoundDataObject;

/**
 * Executes a bitwise value via a TINE link from or to the server. The execution
 * is done by an synchronous TINE link. This interface is derivated from 
 * {@code IExecute}. 
 *
 * @author <a href="marcus.walla at desy.de">walla</a>
 * @version $Id: IExecuteFlag.java 32894 2010-02-08 12:53:07Z walla $
 */
@Deprecated
public interface IExecuteFlag extends IExecute
{

	/**
	 * <p>Calls the execution of an integer flag which is <b>written</b> to 
	 * the server. Taken by this value the corresponding one on the server is 
	 * <b>or</b>-wise associated with this one. Here is an example of the connection
	 * between both:</p>
	 * 
	 * <pre>
	 * server side value (bit by bit )    :     0011 0100 0101 0010
	 * application side value (bit by bit):  or 0001 1001 0100 0100
	 *                                          -------------------
	 *                                          0011 1101 0101 0110
	 * </pre>
	 * 
	 * @param flag_ Is the integer value which should be set.
	 */
	@Deprecated
	public abstract void call(int flag_);
	
	/**
	 * <p>Calls the execution of an array of {@code IEFlag} interfaces for the
	 * corresponding value on the server. This can only be <b>written</b> to the 
	 * server. This means that the corresponding bit position is associated with
	 * an <b>and</b> connection to the server value.</p>
	 *  
	 * @param flags_ An array of the enumeration interface of {@code IEFlag}'s. 
	 */
	@Deprecated
	public abstract void call(IEFlag... flags_);
	
	/**
	 * <p>This will fetch the current results as a list of <tt>TCompoundDataObject</tt>
	 * objects.</p>
	 * <p>Remember that this is the super interface of all compound data objects
	 * from TINE. You should have a look at the TINE java documentation in the
	 * package <tt>de.desy.tine.types</tt>.</p>
	 * 
	 * @return Returns a list of all <tt>TCompoundDataObjects</tt>.
	 */
	@Deprecated
	public abstract Collection<TCompoundDataObject> fetchResult();

}
/* end of file */