/*
 *
 * File: RFDialogModalMessage.java
 * Date: Mar 16, 2009; 5:42:04 PM
 */
package de.desy.mst.libs.accelerator.view;

import java.awt.Component;
import java.awt.Frame;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.GroupLayout;
import javax.swing.Icon;
import javax.swing.JDialog;

import de.desy.mst.libs.accelerator.CGeneralConstant;

/**
 * THIS IS A DEVELOPMENT CLASS AND NEEDS FURTHER DEVELOPMENT IN ITS CURRENT
 * ALGORITHM. DON'T USE THIS CLASS IN PRODUCTIVE CLASSES!
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id$
 */
public final class RFDialogModalMessage {

	/**
	 * Internal enumeration of different messages.
	 *
	 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
	 * @version $Id$
	 */
	private enum EMessage { 
	
		QUESTION("Frage", CGeneralConstant.ICON_MESSAGE_QUESTION_32x32, "Ok", null), 
		INFORMATION("Information", CGeneralConstant.ICON_MESSAGE_INFORMATION_32x32, "Ok", null), 
		WARNING("Warnung", CGeneralConstant.ICON_MESSAGE_WARNING_32x32, "Fortfahren", "Beenden"), 
		ERROR("Fehler", CGeneralConstant.ICON_MESSAGE_ERROR_32x32, "Fortfahren", "Beenden"), 
		FATAL("Fataler Fehler", CGeneralConstant.ICON_MESSAGE_FATAL_32x32, "Beenden", null);
		
		// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		
		private String _title;
		private Icon _icon;
		private String _strButton1;
		private String _strButton2;
		
		// ---------------------------------------------------------------------

		/**
		 * Constructor.
		 * 
		 * @param title_ Title.
		 * @param icon_ Icon.
		 * @param strButton1_ Button 1 label.
		 * @param strButton2_ Button 2 label.
		 */
		EMessage(
				final String title_, 
				final Icon icon_,
				final String strButton1_,
				final String strButton2_)
		{
			validate(title_, icon_, strButton1_);
			initialize(title_, icon_, strButton1_, strButton2_);
		}

		/**
		 * Validates all arguments.
		 * 
		 * @param title_ Title.
		 * @param icon_ Icon.
		 * @param strButton1_ Button 1 label.
		 */
		private void validate(
				final String title_, 
				final Icon icon_,
				final String strButton1_)
		{
			if (title_ == null)
				throw new NullPointerException("Title is null.");
			if (title_.isEmpty())
				throw new IllegalArgumentException("Title is empty.");
			
			if (icon_ == null)
				throw new NullPointerException("Icon is null.");

			if (strButton1_ == null)
				throw new NullPointerException("Button 1 label is null.");
			if (strButton1_.isEmpty())
				throw new IllegalArgumentException("Button 1 label is empty.");
		}
		
		/**
		 * Initializes all arguments.
		 * 
		 * @param title_ Title.
		 * @param icon_ Icon.
		 */
		private void initialize(
				final String title_, 
				final Icon icon_,
				final String strButton1_,
				final String strButton2_)
		{
			_title = title_;
			_icon = icon_;
			_strButton1 = strButton1_;
			_strButton2 = strButton2_;
		}
		
		/**
		 * Returns the title.
		 * 
		 * @return Returns the title.
		 */
		public String getTitle()
		{
			return _title;
		}
		
		/**
		 * Returns the icon.
		 * 
		 * @return Returns the icon.
		 */
		@SuppressWarnings("unused")
		public Icon getIcon()
		{
			return _icon;
		}
		
		/**
		 * Returns the label of button 1.
		 * 
		 * @return Returns the label of button 1.
		 */
		@SuppressWarnings("unused")
		public String getButton1()
		{
			return _strButton1;
		}
		
		/**
		 * Returns the label of button 2.
		 * 
		 * @return Returns the label of button 2.
		 */
		public String getButton2()
		{
			return _strButton2;
		}
	};
	
	// =========================================================================

	/**
	 * 
	 * @param parent_
	 * @param title_
	 * @param message_
	 * @param exception_
	 * @return
	 */
	public static int infoMessage(
			final Component parent_, 
			final String title_,
			final String message_, 
			final Throwable exception_)
	{
		return showMessage(
				EMessage.INFORMATION,
				parent_,
				title_,
				message_,
				exception_);
	}
	
	/**
	 * 
	 * @param title_
	 * @param message_
	 * @param exception_
	 * @return
	 */
	public static int infoMessage(
			final String title_,
			final String message_, 
			final Throwable exception_)
	{
		return showMessage(
				EMessage.INFORMATION,
				null,
				title_,
				message_,
				exception_);
	}
	
	// -------------------------------------------------------------------------
	
	/**
	 * 
	 * @param parent_
	 * @param title_
	 * @param message_
	 * @param exception_
	 * @return
	 */
	public static int warningMessage(
			final Component parent_, 
			final String title_,
			final String message_, 
			final Throwable exception_)
	{
		return showMessage(
				EMessage.WARNING,
				parent_,
				title_,
				message_,
				exception_);
	}

	/**
	 * 
	 * @param title_
	 * @param message_
	 * @param exception_
	 * @return
	 */
	public static int warningMessage(
			final String title_,
			final String message_, 
			final Throwable exception_)
	{
		return showMessage(
				EMessage.WARNING,
				null,
				title_,
				message_,
				exception_);
	}
	
	// -------------------------------------------------------------------------

	/**
	 * 
	 * @param parent_
	 * @param title_
	 * @param message_
	 * @param exception_
	 * @return
	 */
	public static int errorMessage(
			final Component parent_, 
			final String title_,
			final String message_, 
			final Throwable exception_)
	{
		return showMessage(
				EMessage.ERROR,
				parent_,
				title_,
				message_,
				exception_);
	}

	/**
	 * 
	 * @param title_
	 * @param message_
	 * @param exception_
	 * @return
	 */
	public static int errorMessage(
			final String title_,
			final String message_, 
			final Throwable exception_)
	{
		return showMessage(
				EMessage.ERROR,
				null,
				title_,
				message_,
				exception_);
	}
	
	// -------------------------------------------------------------------------

	/**
	 * 
	 * @param parent_
	 * @param title_
	 * @param message_
	 * @param exception_
	 * @return
	 */
	public static int fatalMessage(
			final Component parent_, 
			final String title_,
			final String message_, 
			final Throwable exception_)
	{
		return showMessage(
				EMessage.FATAL,
				parent_,
				title_,
				message_,
				exception_);
	}
	
	/**
	 * 
	 * @param title_
	 * @param message_
	 * @param exception_
	 * @return
	 */
	public static int fatalMessage(
			final String title_,
			final String message_, 
			final Throwable exception_)
	{
		return showMessage(
				EMessage.FATAL,
				null,
				title_,
				message_,
				exception_);
	}
	
	// -------------------------------------------------------------------------

	/**
	 * 
	 * @param message_
	 * @param parent_
	 * @param title_
	 * @param strMessage_
	 * @param exception_
	 * @return
	 */
	private static int showMessage(
			final EMessage message_, 
			final Component parent_, 
			final String title_,
			final String strMessage_, 
			final Throwable exception_)
	{
		if (strMessage_ == null)
			throw new NullPointerException("Message is null");
		if (strMessage_.isEmpty())
			throw new IllegalArgumentException("Message is empty.");
		
		JDialog dialog = new JDialog((Frame) parent_, title_==null?message_.getTitle():title_, true);

		GroupLayout layout = new GroupLayout(dialog);
		dialog.setLayout(layout);
		
		layout.setAutoCreateContainerGaps(true);
		layout.setAutoCreateGaps(true);
		
		final String tmpMessage;
		if (!strMessage_.startsWith("<html>"))
		{
			strMessage_.replaceAll("\n", "<br>");
			tmpMessage = new StringBuilder().append("<html>").append(strMessage_).append("</html>").toString();
		}
		else
			tmpMessage = strMessage_;
	
		if (exception_ != null && message_.getButton2() != null)
			createGroupLayoutBtn2(layout, message_, tmpMessage, exception_);
		else if (exception_ != null && message_.getButton2() == null)
			createGroupLayoutBtn1(layout, message_, tmpMessage, exception_);
		else if (exception_ == null && message_.getButton2() != null)
			createGroupLayoutBtn2(layout, message_, tmpMessage);
		else if (exception_ == null && message_.getButton2() == null)
			createGroupLayoutBtn1(layout, message_, tmpMessage);
		else
			throw new RuntimeException("Misleading values!");
		
		dialog.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
		dialog.addWindowListener(new WindowListener()
		{
			public void windowActivated(WindowEvent e)
			{
				// TODO Auto-generated method stub
				
			}

			public void windowClosed(WindowEvent e)
			{
				// TODO Auto-generated method stub
				
			}

			public void windowClosing(WindowEvent e)
			{
				// TODO Auto-generated method stub
				
			}

			public void windowDeactivated(WindowEvent e)
			{
				// TODO Auto-generated method stub
				
			}

			public void windowDeiconified(WindowEvent e)
			{
				// TODO Auto-generated method stub
				
			}

			public void windowIconified(WindowEvent e)
			{
				// TODO Auto-generated method stub
				
			}

			public void windowOpened(WindowEvent e)
			{
				// TODO Auto-generated method stub
				
			}
			
		});
		dialog.setResizable(false);
		dialog.pack();
		dialog.setVisible(true);
		
		return 0;
	}
	
	private static void createGroupLayoutBtn1(
			final GroupLayout layout_,
			final EMessage message_,
			final String strMessage_)
	{
		
	}

	private static void createGroupLayoutBtn1(
			final GroupLayout layout_,
			final EMessage message_,
			final String strMessage_,
			final Throwable exception_)
	{
		
	}

	private static void createGroupLayoutBtn2(
			final GroupLayout layout_,
			final EMessage message_,
			final String strMessage_)
	{
		
	}
	
	private static void createGroupLayoutBtn2(
			final GroupLayout layout_,
			final EMessage message_,
			final String strMessage_,
			final Throwable exception_)
	{
		
	}
}
/* end of file */