/**
 *
 * Last changed: 2010-4-22
 * By: ws added @Override's
 * URL: $HeadURL$
 * $Revision$
 *
 */
package de.desy.mst.libs.framework.mstapp.appinf.client;

import de.desy.mst.libs.framework.mstapp.appinf.AApplicationInterfaceFactory;
import de.desy.mst.libs.framework.mstapp.appinf.IApp;
import de.desy.mst.libs.framework.mstapp.logging.Logger;

/**
 * @author labudda
 *
 */
public final class ClientFactory extends AApplicationInterfaceFactory  {
	private final static java.util.concurrent.atomic.AtomicReference<IApp> appRef = new java.util.concurrent.atomic.AtomicReference<IApp>(null);
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.IApplikationInterfaceFactory#getApplicationInformation()
	 */
	@Override public IApp getApplicationInformation() throws IllegalStateException {
		if (this.isValidKind()) {
			synchronized (ClientFactory.class) {
				if (ClientFactory.appRef.get() == null) {
					ClientFactory.appRef.set(new ClientApp());
				} else {
					// already done
				}
			}
			Logger.SWFW.debug("Client app info created by factory");
			return ClientFactory.appRef.get();
		} else {
			Logger.SWFW.warn("This is not a console applikation. Exception wil be thrown");
			throw new IllegalStateException("This is not a console applikation");
		}
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.appinf.AApplicationInterfaceFactory#areKindSpecificRequirementsFulfilled()
	 */
	@Override protected boolean areKindSpecificRequirementsFulfilled(){
		return System.getProperty("javawebstart.version", null) != null;
	}
}
