/**
 * 
 * Last changed: $Date$
 * By: $Author$
 * URL: $HeadURL$
 * $Revision$ 
 *
 */
package de.desy.mst.libs.framework.mstapp.appinf.client;

import java.net.URL;


/**
 * @author labudda
 *
 */
class InformationDescDelegated extends Delegated implements IInformationDesc {
	InformationDescDelegated(final Object deletegatedd) {
		super(deletegatedd);
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.IInformationDesc#getHome()
	 */
	@Override public URL getHome() throws UnsupportedOperationException, IllegalArgumentException {
		return (java.net.URL) this.getDelegatedResult("getHome");
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.IInformationDesc#getDescription()
	 */
	@Override public String getDescription() throws UnsupportedOperationException, IllegalArgumentException {
		final int kind = 0;
		return (String) this.getDelegatedResult("getDescription", kind);
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.IInformationDesc#getVendor()
	 */
	@Override public String getVendor() throws UnsupportedOperationException, IllegalArgumentException {
		return (String) this.getDelegatedResult("getVendor");
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.IInformationDesc#getIcons()
	 */
	@Override public IIconDesc[] getIcons() {
		final Object[] objects = (Object[])this.getDelegatedResult("getIcons");
		final IIconDesc[] iconDesc = new IIconDesc[objects.length];
		for (int i = 0; i < iconDesc.length; i++) {
			iconDesc[i] = new IconDescDelegated(objects[i]);
		}
		return iconDesc;
	}

}
