/**
 * 
 * Last changed: $Date$
 * By: $Author$
 * URL: $HeadURL$
 * $Revision$ 
 *
 */
package de.desy.mst.libs.framework.mstapp.appinf.client;


class LaunchDescDelegate extends Delegated implements ILaunchDesc {
	//private final LaunchDesc launchDescription;
	LaunchDescDelegate(final Object launchDescription) {
		super(launchDescription);
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.ILaunchDesc#getVersion()
	 */
	@Override public String getVersion() throws UnsupportedOperationException, IllegalArgumentException {
		return (String) this.getDelegatedResult("getVersion");
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.ILaunchDesc#getAppInfo()
	 */
	@Override public IAppInfo getAppInfo() throws UnsupportedOperationException, IllegalArgumentException {
		final Object appInfo = this.getDelegatedResult("getAppInfo");
		return new AppInfoDelegated(appInfo);
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.ILaunchDesc#getInformation()
	 */
	@Override public IInformationDesc getInformation() throws UnsupportedOperationException, IllegalArgumentException {
		final Object information = this.getDelegatedResult("getInformation");
		return new InformationDescDelegated(information);
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.ILaunchDesc#getResources()
	 */
	@Override public IResourcesDesc getResources() throws UnsupportedOperationException, IllegalArgumentException {
		final Object information = this.getDelegatedResult("getResources");
		return new ResourcesDesc(information);
	}
		
	
}