/**
 * Mar  4, 2010 - Mar  8, 2010	ws:	Creation from scratch
 * Apr 28, 2010 - Apr 28, 2010	ws:	allow modal = FALSE for crashframe
 */
package de.desy.mst.libs.framework.mstapp.hilfe;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Collection;
import java.util.Collections;

import javax.swing.ImageIcon;
import javax.swing.JMenuItem;

import de.desy.mst.libs.framework.mstapp.Main;
import de.desy.mst.libs.framework.mstapp.MstFrameMain;
import de.desy.mst.libs.framework.mstapp.appinf.ApplikationKind;
import de.desy.mst.libs.framework.mstapp.appinf.IApp;
import de.desy.mst.libs.framework.mstapp.appinf.IContactInformation;
import de.desy.mst.libs.framework.mstapp.appinf.ILib;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.security.MstSecurity;

/**
 * Hilfsklasse zur Loesung des Problems:<br>
 * AnLa's appinfo about box anbindung ist sehr aufwendig. Um HelpMgr
 * einigermassen uebersichtlich zu halten werden hier die Komplexitaeten
 * behandelt.
 * <br> Diese Klasse ist sehr schmutzig: Graphische Elemente werden
 * von AnLa von und zur Standard Dialogbox fuer HTML verschoben. Und es
 * gibt einen "schuette" spezifischen Debug Modus.
 * @author ws
 * @version 1.0.0
 */
final class _HelpAbout {
	private final String mnuTitle;
	private final String hlpURI;
//-----------------------------------------------------------------------------
	_HelpAbout(final String mnuTitle, final String hlpURI) {
		this.mnuTitle = mnuTitle;
		this.hlpURI = hlpURI;
	}
//-----------------------------------------------------------------------------
	/**@return appropriate JMenuItem or null*/
	public JMenuItem createMenuItem() {return createMenuItem(false);}
	public JMenuItem createMenuItem(final boolean modal) {
		try{
			final JMenuItem mItem = new JMenuItem(getMnuTitle());
			if(!getAnLaApplicationInformation().isInformationValid())
				return null;
			mItem.addActionListener(new ActionListener(){
				@Override public void actionPerformed(final ActionEvent evt) {
//					showDialog(about);
					try{
						final _AboutDialog about =
						_AboutDialog.createAboutDialog(getFrameMain()
													 , Main.calcAnnotatedTitle(getMnuTitle())
													 , getHlpURI()
													 , getAnLaApplicationInformation()
													 , modal
													 );
						about.setVisible(true);
					}catch(final Throwable th){
						Logger.SWFW.warn(th);
					}
				}
			});
			return mItem;
		}catch(final Throwable th){
			Logger.SWFW.warn("Problem with AnLa about box: " + th, th);
			return null;
		}
	}
//-----------------------------------------------------------------------------
	private final String getMnuTitle() {return this.mnuTitle;}
	private final String getHlpURI  () {return this.hlpURI;}
	@SuppressWarnings("deprecation")
	private MstFrameMain getFrameMain() {return Main.getLastCreatedFrame();}
	//-------------------------------------------------------------------------
	private IApp getAnLaApplicationInformation() {
		try{
			return ApplikationKind.Automatic.getApplicationInformation();
		}catch(final Throwable th){
			Logger.SWFW.warn("Warscheinlich in IDE.", th);
			final boolean isInDebugMode = "schuette".equalsIgnoreCase(MstSecurity.get().getUser());
			return isInDebugMode ? new AnLa_App_DesparatelyDebugging() : null;
		}
	};

//=============================================================================
	private final class AnLa_App_DesparatelyDebugging implements IApp {
		@Override public IContactInformation getContact() {
			return new IContactInformation(){
				@Override public String getEmail() {return "mcs01 @ desy.de";}
				@Override public String getName () {return "mcs01";}
				@Override public String getPhone() {return "8998-...";}
			};
		}
		@Override public String getDescription  () {return "###Sorry only dummy getDescription().";}
		@Override public String getFileTimestamp() {return "###Sorry only dummy getFileTimestamp().";}
		@Override public String getHelp         () {return "###Sorry only dummy getHelp().";}
		@Override public String getHelpBase     () {return "###Sorry only dummy getHelpBase().";}
		@Override public String getHelpUrl      () {return "###Sorry only dummy getHelpUrl().";}
		@Override public ImageIcon getIcon      () {return null;}
		@Override public String getName         () {return "###Sorry only dummy getName().";}
		@Override public String getReleaseReason() {return "###Sorry only dummy getReleaseReason().";}
		@Override public String getTitle        () {return Main.getAppName();}
		@Override public String getVersion      () {return "###Sorry only dummy getVersion().";}
		@Override public Collection<ILib> getJars  () {return Collections.emptyList();}
		@Override public String getReleaseTimestamp() {return "###Sorry only dummy getReleaseTimestamp().";}
		@Override public boolean isInformationValid() {return true;}

	}//End class: AnLa_App_DesparatelyDebugging
}

