/**
 * ws:	Mar  9, 2007 - Mar  9, 2007 creation from scratch
 * ws:	Aug 27, 2008 - Aug 27, 2008	added: getFullFileNameInsideWebServer
 */
package de.desy.mst.libs.framework.mstapp.ini;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.MalformedURLException;

/**
 * Basis Interface fuer den Zugriff auf Developer Spezifische Files. <br>
 * Objekte mit diesem Interface werden von der DeveloperIniFactory erzeugt.
 * @author ws
 * version 1.0.0
 */
public interface IDeveloperFileConnection {
	/**liest vom Web, bei Erfolg und Usererlaubnis Cache Backup sonst vom File*/
	public String read()
		throws FileNotFoundException, MalformedURLException, IOException;

	/**schreibt bei Usererlaubnis (sonst IllegalStateException) nach FileName*/
	public void write(final String string)
		throws FileNotFoundException, IOException, IllegalStateException;

//==============================================================================

	/** Beschreibung der FileSorte (info only)*/
	public String getFileTyp();

	/**Lese Web Adresse*/
	public String getFullWebAddress();

	/**Lese- und Schreib Datei Adresse mit Pfad im Cache*/
	public String getFullFileName();

	/**Lese- und Schreib Datei Adresse mit Pfad auf dem Webserver selbst*/
	public String getFullFileNameInsideWebServer();

	/**If True during write on Cache, write will not throw an IllegalStateException*/
	public boolean isOkForWriting();

}
