/*
 * Created on Apr 26, 2005 - Jun 27, 2005
 *
 */
package de.desy.mst.libs.framework.mstapp.ini;

/**
 * Inifiles sollten immer IIniFileObserver sein.<br><br>
 * 
 * Dieses Interface regelt die Wechselwirkung zwischen
 * dem IniFileHandling des Frameworks mit den jeweiligen
 * Applikationen.<br>
 * Es gibt die Moeglichkeit einen DefaultInifile anzugeben.
 * Man wird vor jedem Schreiben und nach jedem lesen benachrichtigt.<br>
 * 
 * @author schuette
 * @version 1.0.0
 */
public interface IIniFileObserver {
    /**
     * Am Anfang wird ein Default Baum konstruiert.
     * Kann zur Erstellung einer XML Vorlage verwended
     * werden.
     */
    public Object getDefaultIniBaumRoot();

    /**
     * Wird direkt vor dem rausschreiben des IniBaums aufgerufen.<br>
     * Hier kann der Baum noch mal auf den neuesten Stand (intern
     * oder extern) gebracht werden. 
     * @return die neue/alte upgedatete iniBaumRoot (null wird ignoriert)
     */
    public Object onPrepareForExport();
    
    /**
     * Wird nach dem einlesen eines IniBaums aufgerufen (Erstinitialisierung oder Reset).<br>
     * Wird bei jedem beliebigen nicht nur den allgemeinen Inibaum aufgerufen<br>
     */
    public void onNewIniAvailable(Object iniBaumRoot);
}
