/**
 * Sep 1, 2008 - Sep 1, 2008	ws:	Creation from scratch
 */
package de.desy.mst.libs.framework.mstapp.ini;

import java.io.File;
import java.io.IOException;
import java.util.List;

/**
 * Einfache Tabelle (nicht unter Tabellendaten, da nicht relational
 * aber generisch).
 * @author ws
 * @version 1.0.0
 */
public interface ITabelle {
	/**Anzahl der Tabellen Zeilen*/
	public int getSize();
	/**Anzahl der Tabellen Spalten*/
	public int getAnzahlSpalten();

	/**geordnete Liste aller SpaltenTitel*/
	public List<String> getSpaltenTitel();

	/**Die Klasse des Objektes dieser Spalte z.B. String, Long, Double, ...*/
	public Class<?> getTyp(final int iSpalte);

	/**extrahiert den Wert aus der Zeile/Spalte (0 basiert)
	 * <br> typisch String, Long, Double*/
	public Object get(final int iZeile, final int iSpalte);
	/**wie  get(final int iZeile, final int iSpalte) nur ueber Namen*/
	public Object   get(final int iZeile, final String spaltenTitel);


	/**Kommentare sind immer Strings und werden mit getKommentar geholt*/
	public boolean istKommentar(final int iZeile);
	/**String mit Kommentar, istKommentar(final int iZeile) muss true sein*/
	public String getKommentar(final int iZeile);


	/**Die Tabelle kann programmatisch oder via User Interface geaendert werden*/
	public boolean istEditierBar();
	/**true falls inhalt der tabelle geaendert wurde*/
	public boolean isDirty();
	/**Voraussetzung: istEditierBar() == true, wert hat den Typ von getTyp(final int iSpalte)*/
	public void set(final int iZeile, final int iSpalte, final Object wert);
	/**Voraussetzung: istEditierBar() == true, wert hat den Typ von getTyp(final int iSpalte)*/
	public void set(final int iZeile, final String spaltenTitel, final Object wert);

	/**Die Daten werden frisch gelesen, isDirty() ist nun wieder false*/
	public void reloadAllData() throws IOException;
	/**Die Daten werden auf den File file geschrieben, Voraussetzung istEditierBar() == true*/
	public void write(final File file) throws IOException;
}
