/**
 * 	Jul  9, 2015 - Jul 16, 2015	ws:	created from scratch
 */
package de.desy.mst.libs.framework.mstapp.ini;

import java.io.File;

import de.desy.mst.libs.framework.mstapp.ApplicationInfo;
import de.desy.mst.libs.framework.mstapp.Main;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.OPModeACLEntry;

/**
 * Needed for cashing of OPModeACLEntry's, nicht klar getrennt von altem Kram
 * @author ws
 */
class _BaseDataFor_FileOnlyObjects extends ABaseData<IIniFileRoot> {
    public static final String FILETYP = "Datei Cache fuer selbstserialisierende Objekte";
	public static final String SERVICE_NAME = "ObjectCache";
	//=============================================================================================
    public final String shortDescription;
    public final OPModeACLEntry acl;
	//---------------------------------------------------------------------------------------------
    _BaseDataFor_FileOnlyObjects(final OPModeACLEntry acl ) {
    	//tabId entspricht pseudo appName
    	super(acl.getClass().getSimpleName(), retrieveApplicationInfo());
    	this.shortDescription = FILETYP + ": " + acl.toString();
    	this.acl = acl;
    }
	//---------------------------------------------------------------------------------------------
	@Override public String getShortDescription() {return this.shortDescription;}
	@Override protected String calcFileTyp() {return FILETYP;}
	@Override protected String calcFileName(final String appName) {
        final String simpleClassName = this.acl.getClass().getSimpleName();
		final String nakedSimpleFileName = this.acl.calcFileName();
		return calcFileName(simpleClassName, nakedSimpleFileName);
	}
	/**
	 * @param simpleClassName		z.B. "OPModeACLEntry"
	 * @param nakedSimpleFileName   z.B. "ACL(000pcUser111, 000pcName111, 000appName111)"
	 * @return                      z.B. "d:\\mst_app\\ObjectCache\\OPModeACLEntry\\ACL(000pcUser111, 000pcName111, 000appName111).xml"
	 */
	public final static String calcFileName(final String simpleClassName, final String nakedSimpleFileName) {
		return LocalHome.calcLocalPath(SERVICE_NAME, simpleClassName, nakedSimpleFileName, FILE_SUFFIX);
	}
	@Override protected String calcWebAddress() {return null;}
	@Override public void onNewIniAvailable(final Object iniBaumRoot) {}
	//---------------------------------------------------------------------------------------------
	@SuppressWarnings("deprecation") private static ApplicationInfo retrieveApplicationInfo() {
		return Main.getApplicationInfo();
	}
	/**pp for testing*/ boolean delete(final OPModeACLEntry entry) {
		checkUserOkForWriting();//@throws IllegalStateException
		return new File(getFileName()).delete();
	}
}
