/*
 * Created on Jun 21, 2004
 *	Feb 15, 2008 - Feb 15, 2008 ws: added "@Override"es
 *	Aug 29, 2008 - Aug 29, 2008	ws:	catch imageOut == null
 *	Jan  9, 2009 - Jan  9, 2009	ws: createMenuPrintDefaultLogbookPrinter check for null mgr
 *	Mar  2, 2010 - Mar  2, 2010	ws: fixed compiler warnings in printLogbook()
 */
package de.desy.mst.libs.framework.mstapp.io;


import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.awt.print.*;
import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
//import java.io.FileOutputStream;
import java.io.IOException;
//import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Base64;
//import java.util.Iterator;

//import javax.imageio.IIOImage;
import javax.imageio.ImageIO;
//import javax.imageio.ImageWriter;
//import javax.imageio.stream.ImageOutputStream;
//import javax.imageio.plugins.jpeg.JPEGImageWriteParam;
import javax.print.Doc;
import javax.print.DocFlavor;
import javax.print.DocPrintJob;
import javax.print.PrintException;
import javax.print.PrintService;
import javax.print.PrintServiceLookup;
import javax.print.SimpleDoc;
import javax.swing.JMenuItem;

//import sun.misc.BASE64Encoder;

import de.desy.mst.libs.framework.mstapp.appinf.ApplikationKind;
import de.desy.mst.libs.framework.mstapp.appinf.IApp;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.mode.IMaschineObserver;
import de.desy.mst.libs.framework.mstapp.mode.Maschine;
import de.desy.mst.libs.framework.mstapp.mode.MaschineMgr;
;


/**
 * @author K. Hinsch -mst1-
 * &task Printing Frames
 */
public class MstPrintForm  extends MstPrintAll{
	private static JMenuItem menuPrintDefaultLogbookPrinter = null;
	private static Maschine neueMaschine = Maschine.NA;

	private Component myPicture;
    private Maschine maschine;
    private boolean logbookFlag;
    private BufferedImage myImage;

    public void printWithoutDialog(final Component myPicture, final String printer){
    	boolean printerMatch = false;
    	for ( final PrintService s : PrintServiceLookup.lookupPrintServices( null, null ) ){
    		final String attachedPrinter = s.getName();
    		if(printer.equals(attachedPrinter)){
    			try {
    				this.pjob.setPrintService(s);
    			} catch (final PrinterException e) {
    				Logger.SWFW.warn("Kann Drucker nicht setzen.", e);
				}
    			printerMatch = true;
    		}
    	}
    	if(!printerMatch){
    		Logger.SWFW.warn("printWithoutDialog(): Der angegebene Drucker ist nicht auf diesem PC istalliert");
    		return;
    	}
    	this.myPicture = myPicture;
    	this.logbookFlag = false;
    	final mstSnapshot snapshot = new mstSnapshot();
    	this.myPicture.update(this.myPicture.getGraphics());
    	this.myImage= snapshot.captureWindow(this.myPicture.getLocationOnScreen().x, this.myPicture.getLocationOnScreen().y, this.myPicture.getWidth(), this.myPicture.getHeight());
		this.pageformat=this.pjob.defaultPage();
		this.pjob.setCopies(this.pjob.getCopies());
		this.pjob.setPrintable(MstPrintForm.this);
		try {
			printForm(this.myPicture,this.maschine,this.logbookFlag, this.myImage);

		} catch (final PrinterException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		} catch (final IOException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		}
    }
    public void printToDefaultPrinterWithoutDialog(final Component myPicture){
    	this.myPicture = myPicture;
    	this.logbookFlag = false;
    	final mstSnapshot snapshot = new mstSnapshot();
    	this.myPicture.update(this.myPicture.getGraphics());
    	this.myImage= snapshot.captureWindow(this.myPicture.getLocationOnScreen().x, this.myPicture.getLocationOnScreen().y, this.myPicture.getWidth(), this.myPicture.getHeight());
		this.pageformat=this.pjob.defaultPage();
		this.pjob.setCopies(this.pjob.getCopies());
		this.pjob.setPrintable(MstPrintForm.this);
		try {
			printForm(this.myPicture,this.maschine,this.logbookFlag, this.myImage);

		} catch (final PrinterException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		} catch (final IOException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		}
    }
    public void printToLogbookWithoutDialog(final Component myPicture, final Maschine maschine){
		this.myPicture = myPicture;
		this.maschine = maschine;
		this.logbookFlag = true;
   		final mstSnapshot snapshot = new mstSnapshot();
   		this.myPicture.update(this.myPicture.getGraphics());
   		final Point locationOnScreen = this.myPicture.getLocationOnScreen();
		this.myImage = snapshot.captureWindow(locationOnScreen.x, locationOnScreen.y, this.myPicture.getWidth(), this.myPicture.getHeight());
		try {
			printForm(this.myPicture,this.maschine,this.logbookFlag, this.myImage);

		} catch (final PrinterException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		} catch (final IOException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		} catch (final IllegalStateException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		}
    }
    private void printLogbook(final BufferedImage image, final String text, final String title, final String author, final String kennung, final boolean logbook, final boolean mail) throws FileNotFoundException{
    	//try to find out on whis os the program is running
    	final String os = System.getProperty("os.name");
    	Logger.SWApp.info("Betriebssystem: " + os);
    	//set variable
    	boolean systemIsWindows = false;
    	if(os.toLowerCase().contains("windows")){
    		systemIsWindows = true;
    	}
    	//Mail
    	if(mail){
    		final String TextForMail = getTextForMail(text, kennung);
    		new Mail().sendMail(title, TextForMail, author, null, null);
    	}
    	//logbook
    	if(logbook){
	    	final String xmlEncoded = "ISO-8859-1";
            //encode the image
	    	final String base64EncodedImage = encodeImageBase64(image);
            //data to print
	    	final String xmlText =
				"<?xml version=\"1.0\" encoding=\"" + xmlEncoded + "\"?>"+
				"\n<entry>" +
	    			"\n<author>" + author + "</author>" +
	    			"\n<title>" + title + "</title>" +
	    			"\n<text>" + text + "</text>" +
	    			"\n<severity>" + kennung + "</severity>" +
	    			"\n<keywords>Dokumentation</keywords>"+
	    			"\n<image>" + base64EncodedImage + "</image>" +
				"\n</entry>";
	    	try{
				//decode Text to bytes
				final byte[] bytes = xmlText.getBytes(xmlEncoded);
		    	//get "Maschine" and find the logbook 
		    	final LogbookFinder logbookFinder = LogbookFinder.getLogbook(this.maschine);
		    	PrintService service;
		    	if(logbookFinder.getService() != null){
					Logger.SWFW.info("Logbook-Queue: " + logbookFinder.getService().getName());
					service = logbookFinder.getService();
		    	}else{
			    	Logger.SWFW.info("Printer: " + this.pjob.getPrintService().getName());
			    	service = this.pjob.getPrintService();
		    	}
				if(systemIsWindows){//wenn das Programm unter Windows luft
					//Data format
		    	    final DocFlavor flavor = DocFlavor.BYTE_ARRAY.AUTOSENSE;
			    	final Doc doc = new SimpleDoc(bytes, flavor, null);
			    	//create printjob
			    	final DocPrintJob pj = service.createPrintJob();
			    	//print
			    	try {
						pj.print(doc, null);
						Logger.SWFW.info("Print job succeeded");
					} catch (final PrintException e) {//error on printing
						Logger.SWFW.warn("Can't print.", e);
					} 	
				}else{
			        try{
			        	//store data in a file
//			        	File tmpFile = new File("tmpFileForMstAppPrinting.txt");
			        	final File tmpFile = File.createTempFile("tmpFileForMstAppPrinting", ".txt");
			        	tmpFile.deleteOnExit();
			        	Logger.SWApp.info(tmpFile.getPath());
			        	final FileOutputStream fos = new FileOutputStream(tmpFile);
			        	fos.write(bytes);
			        	fos.close();
			        	//read the file and print it
			            final Runtime rt = Runtime.getRuntime();
			            final String[] callArgs = {"lpr","-l","-P",logbookFinder.getService().getName(), tmpFile.getPath()};
			            final Process proc = rt.exec(callArgs);
			            proc.waitFor();
			            //control the data by reading them
			            final BufferedReader pout = new BufferedReader(new InputStreamReader(proc.getInputStream()));
			            final String rcode = pout.readLine();
			            //print a message
			            if (rcode == null) {// data reread succsessfull
			            	Logger.SWFW.info("Print job succeeded");
			            }else {//no data
			            	 Logger.SWFW.warn("Can't print: " + rcode);
			            }
			          }catch(final Exception e){//error on printing
			        	  Logger.SWFW.warn("Can't print.", e);
			          }
			          
					}
			    }catch (final UnsupportedEncodingException e1) {// error on encoding
					Logger.SWFW.warn("Can't print, error encoding.", e1);
				}
    	}
    }
    private String getTextForMail(final String text, final String kennung){
    	final IApp app = ApplikationKind.Automatic.getApplicationInformation();
    	return kennung + "\r\n\r\n"
    	    + "Title: " + app.getTitle() + "\r\n"
    	    + "Version: " + app.getVersion() + "\r\n"
    	    + "File Timestamp: " + app.getFileTimestamp() + "\r\n"
    	    + "Release TimeStamp: " + app.getReleaseTimestamp() + "\r\n\r\n"
    	    + text;
    }
//    private void printLogbook(final BufferedImage image) throws FileNotFoundException{
//    	final JPEGImageWriteParam jpgImw = null;
//    	ImageOutputStream imageOut = null;
//    	final String format="JPEG";
//    	ImageWriter iw = null;
//    	final Iterator<ImageWriter> iter=ImageIO.getImageWritersByFormatName(format);
//    	if(iter.hasNext())
//    		iw = iter.next();
//    	if(iw == null)
//    		return;
//    	try {
//    		Logger.SWApp.error(this.pjob.getPrintService().getName());
//    		final File f = new File(this.pjob.getPrintService().getName());
////    		final File f = new File("//adprint7/PETRAlog");
//    		imageOut = ImageIO.createImageOutputStream(f);
//    		iw.getDefaultStreamMetadata(jpgImw);
//    		iw.setOutput(imageOut);
//    		final IIOImage iioImage= new IIOImage(image, null, null);
//    		iw.write(iioImage);
//		} catch (final IOException e1) {
//			Logger.SWFW.warn("Kann nicht drucken.", e1);
//		} catch (final Throwable e1){
//			Logger.SWFW.warn("Kann nicht drucken.", e1);
//		}
//		if(imageOut != null)
//			try {imageOut.close();
//			} catch (final IOException ex) {
//				Logger.SWFW.warn("Kann imageOut nicht schliessen.", ex);
//			} catch (final Throwable ex){
//				Logger.SWFW.warn("Kann imageOut nicht schliessen.", ex);
//			}
//		iw.dispose();
//    }
	private String encodeImageBase64(final BufferedImage image){
		final ByteArrayOutputStream os = new ByteArrayOutputStream();
//		JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(os);
//		try {
//			encoder.encode(image);
//		} catch (ImageFormatException e) {
//			Logger.SWFW.error("Drucken ins Logbuch Encoding Base64: Das Bild hat nicht das richtige Format", e);
//		} catch (IOException e) {
//			Logger.SWFW.error("Drucken ins Logbuch Encoding Base64: IoException", e);
//		}
		try {
			ImageIO.write(image, "jpg", os);
		} catch (final IOException e) {
			Logger.SWFW.error("Drucken ins Logbuch Bild umwandeln: IoException", e);
		}
		final byte[] pixelsAsByte = os.toByteArray();
		
		final String base64encodedString = Base64.getEncoder().encodeToString(pixelsAsByte);
		return base64encodedString;
	}
	public void printForm(final Component myPicture, final Maschine maschine, final boolean LogbookFlag, final BufferedImage image) throws PrinterException, IOException {
		this.myPicture = myPicture;
		this.maschine = maschine;
		this.logbookFlag = LogbookFlag;
		this.myImage = image;
		this.fph = new FilePrintHelper();
		if (this.logbookFlag == false){
			this.pjob.print();
		}else{
//	    	for ( final PrintService s : PrintServiceLookup.lookupPrintServices( null, null ) ){
//	    		final String attachedPrinter = s.getName();
//	    		final String printer = maschine.logBuchName.toLowerCase() + "log";
//	    		if(printer.equals(attachedPrinter)){
//	    			try {
//	    				this.pjob.setPrintService(s);
//	    			} catch (final PrinterException e) {
//	    				Logger.SWFW.warn("Kann Drucker nicht setzen.", e);
//					}
//	    		}
//	    	}
//			printLogbook(this.myImage);
			printLogbook(this.myImage, "", "", "", "", true, false);
		}
	}
	public void printForm(final Component myPicture, final Maschine maschine, final boolean logbookFlag, final BufferedImage image, final String text, final String title, final String author, final String kennung, final boolean mail) throws PrinterException, IOException {
//		this.myPicture = myPicture;
//		this.maschine = maschine;
//		this.logbookFlag = logbookFlag;
//		this.myImage = image;
//		fph = new FilePrintHelper();
//		if (this.logbookFlag == false){
//			pjob.print();
//		}else{
//			printLogbook(image, text, title, author, kennung, mail);
//		}
		printForm(myPicture, maschine, logbookFlag, image, text, title, author, kennung, true, mail);
	} 
	public void printForm(final Component myPicture, final Maschine maschine, final boolean logbookFlag, final BufferedImage image, final String text, final String title, final String author, final String kennung,final boolean logbook,  final boolean mail) throws PrinterException, IOException {
		this.myPicture = myPicture;
		this.maschine = maschine;
		this.logbookFlag = logbookFlag;
		this.myImage = image;
		this.fph = new FilePrintHelper();
		if (this.logbookFlag == false){
			this.pjob.print();
		}else{
			printLogbook(image, text, title, author, kennung, logbook, mail);
		}
	}

	//---Implementierung von Printable-------------------
	@Override
	public int print(final Graphics g, final PageFormat pf, final int page) throws PrinterException{
		int ret = PAGE_EXISTS;
		boolean drawPicture;
		try {
			if (this.fph.knownPage(page)) {
				//long k = fph.getFileOffset(page);
				drawPicture = true;
			}
			else {
				long offset = 0;
				if (this.myPicture !=null ){
					offset = 0;
					this.fph.createPage(page);
					this.fph.setFileOffset(page, offset);
				} else {
					ret = NO_SUCH_PAGE;
				}
				drawPicture = false;
			}
			if (ret == PAGE_EXISTS) {
				Graphics2D g2 = (Graphics2D)g;
				final double PageHeight = pf.getHeight()-(pf.getImageableY()*2);
				final double PageWidth = pf.getWidth()-(pf.getImageableX()*2);
				final double PicHeight = this.myImage.getHeight();
				final double PicWidth = this.myImage.getWidth();
				double ScaleHeight = PageHeight/PicHeight;
				double ScaleWidth = PageWidth/PicWidth;
				if (ScaleHeight < ScaleWidth){
					ScaleWidth = ScaleHeight;
				}
				if (ScaleWidth < ScaleHeight) {
					ScaleHeight = ScaleWidth;
				}
				g2.translate(pf.getImageableX(),pf.getImageableY());
				g2.scale(ScaleWidth, ScaleHeight);
//				int ypos = (int)(((PageHeight-PicHeight)/2 )+ pf.getImageableY());
//				int xpos = (int)(((PageWidth-PicWidth)/2)+ pf.getImageableX()) + 4;
//				this.myPicture.printAll(g2);
				g2.drawImage(this.myImage,0,0,this.imo);
				g2.dispose();
				g2 = null;
				if (drawPicture == true) {
					this.myPicture = null;
				}
			}
		} catch (final Exception e) {
			throw new PrinterException(e.toString());
		}
		return ret;
	}

	public MstPrintForm() {
		this.pjob  = PrinterJob.getPrinterJob();
	}
	public static JMenuItem getMenuPrintDefaultPrinter(final Component c){
		final Component component = c;
		final JMenuItem jMenuItemPrintDefault = new JMenuItem();
		jMenuItemPrintDefault.setText("Drucken Standarddrucker");
		jMenuItemPrintDefault.addActionListener(new ActionListener() {
			@Override public void actionPerformed(final ActionEvent evt) {
				final MstPrintForm myPrinter=new MstPrintForm();
				myPrinter.printToDefaultPrinterWithoutDialog(component);
			}
		});
		return jMenuItemPrintDefault;
	}
	public static JMenuItem getMenuPrintDefaultLogbookPrinter(final Component cmp, final MaschineMgr mgr){
//		if(menuPrintDefaultLogbookPrinter == null){
			createMenuPrintDefaultLogbookPrinter(cmp, mgr);
//		}
		return menuPrintDefaultLogbookPrinter;
	}
	private static void createMenuPrintDefaultLogbookPrinter(final Component cmp, final MaschineMgr mgr) {
		menuPrintDefaultLogbookPrinter = new JMenuItem();

		if(mgr != null){
			mgr.registerIMaschineObserver(new IMaschineObserver(){
				@Override public void onMaschineChange(final Maschine neueMaschine) {
					onMaschineChange_(neueMaschine);
				}
			});
		}else{
			onMaschineChange_(Maschine.NA);
		}

		menuPrintDefaultLogbookPrinter.addActionListener(new ActionListener() {
			@Override public void actionPerformed(final ActionEvent evt) {
				final MstPrintForm myPrinter = new MstPrintForm();
				myPrinter.printToLogbookWithoutDialog(cmp , neueMaschine);
			}
		});
	}
	private static void onMaschineChange_(final Maschine neueMaschine) {
		MstPrintForm.neueMaschine = neueMaschine;
		final String text = "Drucken " + neueMaschine.getLogBuchName()
									   + " Logbuch";
		menuPrintDefaultLogbookPrinter.setText(text);
		menuPrintDefaultLogbookPrinter.setEnabled(neueMaschine.hasLogbuch());
	}
}
