/**
 *  Created on  Aug 07, 2006 - Aug 08, 2006	ws
 *  
 */
package de.desy.mst.libs.framework.mstapp.logging;

import java.util.Date;
import java.util.UUID;

import de.desy.mst.libs.framework.mstapp.util.MstDateFormat;
import de.desy.mst.libs.framework.mstapp.util.StringPadding;

/**
 * Default Format fuer die einzahlige Darstellung von Server Logging Eintraegen.
 * 
 * @author ws
 * @version 1.0.0
 */
public class ServerFormatter extends EinfacherLogFormatter {
	public static final int DEFAULT_NR_LENTH   =  7;
	public static final int DEFAULT_TEXT_LENTH = 30;

	private StringPadding nrPadding;
	private StringPadding textPadding;
	
//	=============================================================================
		
	public ServerFormatter(){
		super();
		this.setNrPadding(DEFAULT_NR_LENTH);
		this.setFormatDate(MstDateFormat.KURZ.getIFormatAsString());
		this.setTextPadding(DEFAULT_TEXT_LENTH);
	}
	
//=============================================================================
	
	/**>0*/				public int  getNrPadding()					{return this.nrPadding.STRING_SIZE;}
	/**muss > 0 sein*/	public void setNrPadding(final int nrPadding)		{this.nrPadding = new StringPadding(nrPadding);}
	
	/**>0*/				public int  getTextPadding()				{return this.textPadding.STRING_SIZE;}
	/**muss > 0 sein*/	public void setTextPadding(final int textPadding)	{this.textPadding = new StringPadding(textPadding);}
	
	/**Padding konformer Titel*/
	public String getTitel(final String nrSpaltenName, final String datumsSpaltenName, final String textSpaltenName) {
		final int dateLength = getFormatDate().format(new Date()).length(); 
		return	( new StringPadding(this.nrPadding.STRING_SIZE)	).format(nrSpaltenName)
			+	( new StringPadding(dateLength)				).format(datumsSpaltenName)
			+	( this.textPadding						 	).format(decorate(msgFormat(textSpaltenName)))
			;
	}

	@Override public String          nrFormat(final long nr)			{return this.nrPadding.format(Long.toString(nr));}
	@Override public String       levelFormat(final LogLvl level) 		{return "";}
	@Override public String   kategorieFormat(final Logger logKategorie){return "";}
	@Override public String          decorate(final String string) 		{return /*textPadding.format*/(" " + string);}
	@Override public String applikationFormat(final String application)	{return "";}
	@Override public String 	 pcNameFormat(final String pcName)		{return "";}
	@Override public String		  runIdFormat(final UUID runId) 		{return "";}
	@Override public String getSEPARATOR_InMSG() 						{return "";}
} 
