/**
 * ws:	Sep 12, 2007 - Sep 12, 2007 creation from PfadeIni
 * ws:	Feb  5, 2008 - Feb  5, 2008 SRV_NAME private -> public
 *	Jul 14, 2008 - Jul 14, 2008	ws: add getSystemRoot_Datei()
 *	Aug  1, 2008 - Aug  1, 2008	ws:	FILE_SUFFIX = ".mlp" != log Eindeutigkeit
 * 	Aug 15, 2008 - Aug 15, 2008	ws: getAppOrALName() impl
 * 	Sep 16, 2008 - Sep 16, 2008	ws:	getHome -> getHomeProtokoll
 */
package de.desy.mst.libs.framework.mstapp.logging.appender.file;

import java.io.File;

import de.desy.mst.libs.framework.mstapp.ApplicationInfo;
import de.desy.mst.libs.framework.mstapp.hilfe.AHilfePfadeAL;
import de.desy.mst.libs.framework.mstapp.ini.LocalHome;
import de.desy.mst.libs.framework.mstapp.ini.WebHome;

/**
 * FilePfad zu den Protokolldaten, aus virtueller Webadresse berechnet
 * @author ws
 * @version 1.0.0
 */
public class PfadeProtokoll extends AHilfePfadeAL {
	public  static final String SRV_NAME 	= "Protokoll";
	public  static final String FILE_SUFFIX = ".mlp";//Mst Logging & Protokolle
	private static final String ROOT = WebHome.getHttp_Base_Address()
									 + SRV_NAME
									 + "/";
//=============================================================================
	final private String fileName;
//=============================================================================
	public PfadeProtokoll(final ApplicationInfo applicationInfo) {
		this(applicationInfo, null);
	}
	/**fileName in/exclusive Suffix*/
	public PfadeProtokoll(final ApplicationInfo applicationInfo, final String fileName) {
		super(applicationInfo);
		this.fileName = (fileName == null) ?
						(decorateFileName(SRV_NAME)) :
						(decorateFileName(fileName));
	}
//===========================================================================
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.hilfe.AHilfePfadeAL#getDateiName(java.lang.String)
	 */
	@Override public String getDateiName(final String appName) {return this.fileName;}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.hilfe.AHilfePfadeAL#getSubSystemRoot()
	 */
	@Override public String getSubSystemRoot() {return getSystemRoot();}
	//-----------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.hilfe.IHilfePfade#getSystemRoot()
	 */
	@Override public String getSystemRoot()  {return ROOT;}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.hilfe.AHilfePfade#getAppOrALName(de.desy.mst.libs.framework.mstapp.ApplicationInfo)
	 */
	@Override public String getAppOrALName(final ApplicationInfo applicationInfo) {
		return applicationInfo.getAppName();
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.hilfe.AHilfePfade#getCacheRoot()
	 */
	@Override public String getCacheRoot() {return LocalHome.getHomeProtokoll();}
	
	
	/**Caching must be allowed*/
	public String getSystemRoot_Datei(){
		return 	LocalHome.getHomeProtokoll()+ SRV_NAME + File.separator;
	}
//-----------------------------------------------------------------------------

	private String decorateFileName(final String fileName) {
		final String appName = getApplicationInfo().getAppName();
		final String bare = cleanName(appName) + SEP + cleanName(fileName);
		return (fileName.contains("."))
							?  bare					//hat schon suffix
							: (bare + FILE_SUFFIX);	//braucht suffix wie ".txt"
	}
}
