/**
 *  Created on	Jan 31, 2006 - Feb 02, 2006
 *	Feb 15, 2008 - Feb 15, 2008 ws: added "@Override"es
 *	Feb 15, 2009 - Feb 15, 2009 ws: fixed add
 */
package de.desy.mst.libs.framework.mstapp.logging.filter;

import java.util.ArrayList;
import java.util.List;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import de.desy.mst.libs.framework.mstapp.logging.LogMsg;

/**
 * Manages collections von Filtern
 * @author ws
 * @version 1.0.0
 */
public abstract class ALogCollectionFilter<T extends ILogFilter> extends ALogFilter {
	public final String NAME;
	private final List<T> dieFilter = new ArrayList<T>();

//=============================================================================

	public ALogCollectionFilter(final String name) {
		super();
		this.NAME = name;
	}

//=============================================================================

	/* (non-Javadoc)
	 * @see de.desy.mst.mstapp.logging.filter.ALogFilter#passOnStandardModus(de.desy.mst.mstapp.logging.LogMsg)
	 */
	@Override protected boolean passOnStandardModus(final LogMsg logMsg){return passOnStandardModus(logMsg, this.dieFilter);}

	/* (non-Javadoc) 
	 * @see de.desy.mst.mstapp.logging.filter.ALogFilter#decorateElement(org.w3c.dom.Document, org.w3c.dom.Element)
	 */
	@Override protected void decorateElement(final Document document, final Element element) {
		for (final T filter : this.dieFilter) {
			if(filter != null){
				element.appendChild(   filter.getBeschreibungAsElement(document)   );
				}
		}
	}

//=============================================================================

	public final int	 size()						{return this.dieFilter.size();}
	public final boolean contains(final T filter)	{return this.dieFilter.contains(filter);}
	public final boolean remove  (final T filter)	{return this.dieFilter.remove(filter);}
	public final void 	 clear()					{this.dieFilter.clear();}

	public final boolean add(final T filter){
		if(filter == null)
			return false;
		if(this.contains(filter))
			return false;
		return this.dieFilter.add(filter);
	}

//=============================================================================

	/**zum implementieren von pass(...), dieFilter: never null*/
	protected abstract boolean passOnStandardModus(final LogMsg logMsg, final List<T> dieFilter);

}
