/**
 *  Created on	Jan 31, 2006 - Feb 01, 2006
 */
package de.desy.mst.libs.framework.mstapp.logging.filter;

import java.util.List;

import de.desy.mst.libs.framework.mstapp.logging.LogMsg;

/**
 * <b>Composite Filter fuer andere Filter.</b><br>
 * pass == true, falls alle seine Subfilter bei pass ein true ergibt.
 * Keine Subfilter => true
 * (Logisches und bei pass auf die SubFilter)
 * <br>
 * 
 * @author ws
 * @version 1.0.0
 */
public class UndLogFilter<T extends ILogFilter> extends ALogCollectionFilter<T>{
	@SafeVarargs
	public UndLogFilter(final T ... filter) {
		super("UndLogFilter");
		for (final T einFilter : filter) {add(einFilter);}
	}
	//public UndLogFilter() {this(null);}
	
//=============================================================================
	
	/* (non-Javadoc)
	 * @see de.desy.mst.mstapp.logging.filter.ALogCollectionFilter#pass(de.desy.mst.mstapp.logging.LogMsg, java.util.List)
	 */
	@Override
	protected boolean passOnStandardModus(final LogMsg logMsg, final List<T> dieFilter) {
		for (final T filter : dieFilter) {
			if(!filter.pass(logMsg)) {return false;}
		}
		return true;
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.mstapp.logging.filter.ALogFilter#getName()
	 */
	@Override protected String getName() {return this.NAME;}
} 