/**
 * 	May 14, 2009 - May 25, 2009	ws:	Creation from scratch
 * 	Jul  3, 2009 - Jul  6, 2009	ws:	make public so I can export the Info for Display in GUI
 * 	Jul 22, 2009 - Jul 22, 2009	ws:	add ClsLogInfo create(final Clog cLog)
 */
package de.desy.mst.libs.framework.mstapp.logging.map_tinelogsrv;

import de.desy.tine.server.logger.Clog;
import de.desy.tine.server.logger.ClsLog.ClogPriority;
import de.desy.tine.server.logger.ClsLog.ClogStatus;

/**
 * All 6 Params needed for
 * ClsLog.log(String text,String context,String tag,String caller,ClogPriority priority,ClogStatus status)
 * @author ws
 * @version 1.0.0
 */
public abstract class ClsLogInfo{
	public static ClsLogInfo create(final String text
								  , final String context
								  , final String tag
								  , final String callerLogger
								  , final ClogPriority priority
								  , final ClogStatus status) {
		if(isSystemContext(context))
			return new __ClsLogInfoSystem   (text         , tag, callerLogger, priority, status);
		else
			return new __ClsLogInfoNonSystem(text, context, tag, callerLogger, priority, status);
	}
	public static ClsLogInfo create(final Clog cLog) {
		return create(cLog.getText()
					, cLog.getContext()
					, cLog.getTag()
					, cLog.getLogger()
					, ClogPriority.values()[cLog.getPriority()]
					, ClogStatus  .values()[cLog.getStatus()]);
	}
	public static String getSystemContext() {return __IDataMapping.SYSTEM_KONTEXT;}
	public static boolean isSystemContext(final String context) {
		return getSystemContext().equals(context);
	}
//=============================================================================
	public final String text;
	public final String context;
	public final String tag;
	public final String callerLogger;
	public final ClogPriority priority;
	public final ClogStatus status;
//=============================================================================
	/**pp, use only in super of subclasses (enforced via abstract class)*/
	ClsLogInfo(final String text
			 , final String context
			 , final String tag
			 , final String callerLogger
			 , final ClogPriority priority
			 , final ClogStatus status) {
		this.text = text;
		this.context = context;
		this.tag = tag;
		this.callerLogger = callerLogger;
		this.priority = priority;
		this.status = status;
	}
//=============================================================================
	abstract public boolean isSystemInfo();

	@Override public String toString() {
		final StringBuilder sb = new StringBuilder();
		sb.append("__ClsLogInfo: ")
		  .append("\n").append("         Text = ").append(this.text)
		  .append("\n").append("      Context = ").append(this.context)
		  .append("\n").append("          Tag = ").append(this.tag)
		  .append("\n").append("Caller/Logger = ").append(this.callerLogger)
		  .append("\n").append("     Priority = ").append(this.priority)
		  .append("\n").append("       Status = ").append(this.status )
		  ;
		return sb.toString();
	}
	@Override public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime
				* result
				+ ((this.callerLogger == null) ? 0 : this.callerLogger
						.hashCode());
		result = prime * result
				+ ((this.context == null) ? 0 : this.context.hashCode());
		result = prime * result
				+ ((this.priority == null) ? 0 : this.priority.hashCode());
		result = prime * result
				+ ((this.status == null) ? 0 : this.status.hashCode());
		result = prime * result
				+ ((this.tag == null) ? 0 : this.tag.hashCode());
		result = prime * result
				+ ((this.text == null) ? 0 : this.text.hashCode());
		return result;
	}
	@Override public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final ClsLogInfo other = (ClsLogInfo) obj;
		if (this.callerLogger == null) {
			if (other.callerLogger != null)
				return false;
		} else if (!this.callerLogger.equals(other.callerLogger))
			return false;
		if (this.context == null) {
			if (other.context != null)
				return false;
		} else if (!this.context.equals(other.context))
			return false;
		if (this.priority == null) {
			if (other.priority != null)
				return false;
		} else if (!this.priority.equals(other.priority))
			return false;
		if (this.status == null) {
			if (other.status != null)
				return false;
		} else if (!this.status.equals(other.status))
			return false;
		if (this.tag == null) {
			if (other.tag != null)
				return false;
		} else if (!this.tag.equals(other.tag))
			return false;
		if (this.text == null) {
			if (other.text != null)
				return false;
		} else if (!this.text.equals(other.text))
			return false;
		return true;
	}
}
