/**
 * May 15, 2009 - May 15, 2009	ws:	Creation from _MapEntireMsg
 * Sep 22, 2009 - Sep 22, 2009	ws:	added mapSRunId(sRunId)
 */
package de.desy.mst.libs.framework.mstapp.logging.map_tinelogsrv;

import java.util.UUID;

/**
 * bis jetzt nur eine Implementation im Singleton _MapRunId.get()
 * @author ws
 * @version 1.0.0
 */
class __MapRunId{
	private static final __MapRunId instance = new __MapRunId();
	//-------------------------------------------------------------------------
	public static final __MapRunId get() {return instance;}
//=============================================================================
	private __MapRunId() {}
	//-------------------------------------------------------------------------
	/**MstLog -> Clog, "-" removed due to 32 char limit*/
	public final String map(final UUID runId){
		return mapSRunId(runId.toString());
	}
	public String mapSRunId(final String sRunId) {
		return sRunId.replace("-", "");
	}
	/**MstLog <- Clog, "-" reinserted again*/
	public final UUID map(final String callerOrLogger){
		//"        8   12  16  20          "
		//"          1         2         3 "
		//"01234567890123456789012345678901"
		//"00000000111122223333444444444444" =>
		//"00000000-1111-2222-3333-444444444444"
		final StringBuilder sb = new StringBuilder(32+4);
		sb.append(safeExtract(callerOrLogger,  0,  8)).append('-')
		  .append(safeExtract(callerOrLogger,  8, 12)).append('-')
		  .append(safeExtract(callerOrLogger, 12, 16)).append('-')
		  .append(safeExtract(callerOrLogger, 16, 20)).append('-')
		  .append(safeExtract(callerOrLogger, 20, callerOrLogger.length()))
		  ;
		final String sUUID = sb.toString();
		try {return UUID.fromString(sUUID);}
		catch (final IllegalArgumentException ex) {
			return UUID.fromString("00000000-0000-0000-0000-000000000000");
		}
	}
	//-------------------------------------------------------------------------
	private static String safeExtract(final String tCaller
									, final int beginIndex
									, final int endIndex) {
		try {return tCaller.substring( beginIndex,  endIndex);}
		catch (final StringIndexOutOfBoundsException ex)	{return "0";}
	}
}