/**
 * 	May 25, 2009 - May 28, 2009	ws:	Creation from scratch/__SystemInfoFactory
 *	Jul 24, 2009 - Jul 24, 2009	ws:	shorter Text in LogMsg of System Message 
 */
package de.desy.mst.libs.framework.mstapp.logging.map_tinelogsrv;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import de.desy.mst.libs.framework.mstapp.util.MstDate;
import de.desy.mst.libs.framework.mstapp.util.MstDateFormat;
import de.desy.mst.libs.framework.mstapp.util.MstDateFormatISOParser;

/**
 * Mapper For Heartbeat/System Texts
 * @author ws
 * @version 1.0.0
 */
class __MapTextSystem {
	private static final String EQ = " = ";
	private static final String SEP = "; ";
	private static final String KEY_HEARTBEAT = "HeartBeat";
	private static final String KEY_STARTZEIT = "Startzeit";
	private static final String KEY_LAUFZEIT  = "Laufzeit";
	private static final String KEY_DATUM 	  = "Datum";
	private static final String KEY_PCNAME    = "PCName";
	private static final String KEY_HEADER    = "Header";

	static final String HEADER 		= "Nr,Date,Kategorie,Eintrag";

//	static final String TXT_HB = "HeartBeat = " + NHB 		+ "; "
//							   + "Startzeit = " + SSTARTDATE+ "; "
//	   						   + "DATUM = " 	+ DATUM 	+ "; "
//							   + "Laufzeit = "  + LAUFZEIT	+ "; "
//							   + "PCName = " 	+ PCNAME	+ "; "
//							   + "Header = Nr,Date,Kategorie,Eintrag; ";
//=============================================================================
	public static final __MapTextSystem create(final long msNow
											 , final long nHB
											 , final Date start
											 , final String pcName
											 , final String tContext
	) {
		final String sStart = getISODateString(start);
		final long msLaufzeit = msNow - start.getTime();
		final Date now = new Date(msNow);
		final String   tText = buildTText(nHB, pcName, sStart, msLaufzeit, now);
		final String msgText = buildMsgText(nHB, sStart, msLaufzeit);
		final boolean hasParseProblems = false;
		return new __MapTextSystem(tText, tContext, nHB, start, now, pcName, hasParseProblems, msgText);
	}
		private static String buildTText(final long nHB, final String pcName, final String sStart, final long msLaufzeit, final Date now) {
			final StringBuilder sb = new StringBuilder();
			sb.append(KEY_HEARTBEAT).append(EQ).append(nHB			  		 ).append(SEP)
			.append(KEY_STARTZEIT).append(EQ).append(sStart).append(SEP)
			.append(KEY_DATUM    ).append(EQ).append(MstDateFormat.ISO.format(now)).append(SEP)
			.append(KEY_LAUFZEIT ).append(EQ).append(__MapTextSystem.getDauer(msLaufzeit)).append(SEP)
			.append(KEY_PCNAME   ).append(EQ).append(pcName	  ).append(SEP)
			.append(KEY_HEADER   ).append(EQ).append(getHEADER()).append(SEP)
			;
			return sb.toString();
		}
		private static String buildMsgText(final long nHB, final String sStart, final long msLaufzeit) {
			final StringBuilder sb = new StringBuilder();
			sb.append(KEY_HEARTBEAT).append(EQ).append(nHB			  		 ).append(SEP)
			  .append(KEY_STARTZEIT).append(EQ).append(sStart).append(SEP)
			  .append(KEY_LAUFZEIT ).append(EQ).append(__MapTextSystem.getDauer(msLaufzeit)).append(SEP)
			   ;
			return sb.toString();
		}
	private static __MapTextSystem create(final String	tText
										, final String  tContext
										, final long	nHB
										, final Date	start
										, final Date    now
										, final String	pcName
										, final boolean hasParseProblems
										, final String  msgText
										) {
		return new __MapTextSystem(tText, tContext, nHB, start, now, pcName, hasParseProblems, msgText);
	}
	public static final __MapTextSystem create(final String tText){
		return create(tText, __IDataMapping.SYSTEM_KONTEXT);
	}
	public static final __MapTextSystem create(final String tText, final String tContext){
		final String[] pairs = tText.split(SEP);
		final Map<String, String> map = new HashMap<String, String>(6);
		for (String pair : pairs) {
			final String[] s = pair.split(EQ);
			if(s.length < 2)
				continue;
			map.put(s[0], s[1]);
		}
		final String pcName	= map.get(KEY_PCNAME);
		try {
			final long nHB		= getLong(KEY_HEARTBEAT, map);
			final String sNow	= map.get(KEY_DATUM);
			final String sStart	= map.get(KEY_STARTZEIT);
			final Date now = MstDateFormatISOParser.parse(sNow);
			final Date start = MstDateFormatISOParser.parse(sStart);
			final boolean hasParseProblems = false;
			final long msLaufzeit = now.getTime() - start.getTime();
			final String msgText = buildMsgText(nHB, sStart, msLaufzeit);
			return create(tText, tContext, nHB, start, now, pcName, hasParseProblems, msgText);
		} catch (Exception ex) {//ParseException, NumberFormatException
			final boolean hasParseProblems = true;
			final long nHB		= -9999;
			final String annotatetTText = tText + ex.getMessage();
			return create(annotatetTText, tContext, nHB, new Date(0), new Date(0), pcName, hasParseProblems, annotatetTText);
		}
	}

	private static Long getLong(final String key, final Map<String, String> map) {
		return Long.valueOf(map.get(key));
	}
//-----------------------------------------------------------------------------
	/**Dauer ... Zeitraum Programm Start bis End typisch currentTimeMillis*/
	private static final String getDauer(final long msLaufzeit) {
		return MstDate.msIntervalToText(msLaufzeit);
	}
	private final static String getISODateString (final Date dateStart) {
		return MstDateFormat.ISO.format(dateStart);
	}
	private final static String getHEADER() {return HEADER;}

//=============================================================================
	final String tText;
	final String tContext;

	final long nHB;
	final Date start;
	final Date now;
	final String pcName;

	final boolean hasParseProblems;
	
	final String msgText;
//-----------------------------------------------------------------------------
	__MapTextSystem(final String tText
				  , final String tContext
				  , final long nHB
				  , final Date start
				  , final Date now
				  , final String pcName
				  , final boolean parseProblems
				  , final String msgText
				  ) {
		this.tText = ("" + tText).trim();
		this.tContext = tContext;

		this.nHB 	= nHB;
		this.start	= start;
		this.now	= now;
		this.pcName	= pcName;

		this.hasParseProblems = parseProblems;
		
		this.msgText = ("" + msgText).trim();
	}
//-----------------------------------------------------------------------------
	public boolean 	hasParse() {return  this.hasParseProblems;}

	/**System Messages have no LogMsg Nr, therefore -nHB (sign distinguished)*/
	public long    getLogMsgNr()		{return -this.nHB;}
	public Date    getLogMsgDate()		{return  this.now;}
	public String  getLogMsgMessage()	{
		return  __MapContext.map(this.tContext, getRawLogMsgMessage());
	}
//-----------------------------------------------------------------------------
	private String getRawLogMsgMessage(){return  this.msgText;}
}


