/**
 * ????          - ???? 		wst: creation
 * Feb 15, 2007 - Feb 15, 2007	ws:	updated onDispose Comment
 * May 16, 2007 - May 16, 2007	ws:	rename PrefString -> SaveString
 * 									(Konsistenz zu IPrefClient)
 * Oct 15, 2008 - Oct 15, 2008	ws: setParent(...) mit throws IllegalArgumentException
 * Jun 24, 2009 - Jun 24, 2009	ws: onNewSaveString(...) mit throws Exception
 */
package de.desy.mst.libs.framework.mstapp.preferences;

import java.awt.Component;

/**
 * Basisinterface fuer spezifische Preferenzes (nichtgrafischer Teil)<br>
 * Implementationshilfe: APreferences<br>
 * @author wst, ws
 * version 1.0.0
 */
public interface IPreferences {

	/**Null oder das uebergeordnete Element nie selbst.*/
	public void setParent(IPreferences iU) throws IllegalArgumentException;
	/**Null oder das uebergeordnete Element.*/
	public IPreferences getParent();
	public String getTitle();
	/**
	 * Schluesselworte, die das Panel beschreiben
	 * (fuer spaeter um Eclipse Preferences Textbox oben links zu emulieren)
	 */
	public String[] getKeyWords();
	/**
	 * @return	Bitte frische Component, typisch ein Panel zum Einstellen der
	 * 			Preferences, uebergeben. Referenzen hierauf etc. spaetestens bei
	 * 			onDispose() aufgeben ( = null setzen).
	 */
	public Component getPrefComponent(final IPrefContainer prefContainer);
	/**
	 *
	 * @see 	de.desy.mst.libs.framework.mstapp.preferences.IPrefClient
	 * @return	Call Back Interface fuer PrefContainer (kann dort auch
	 * 			implementiert werden).
	 */
	public IPrefClient getPrefClient();

	/**
	 * Das Panel wird gleich geschlossen. Bitte alle offenen Referenzen und
	 * Resourcen zurueckgeben. Insbesondere keine Referenzen mehr auf den
	 * IPreferenceContainer halten, um hier die allerletzten Referenzen
	 * aufzugeben.
	 * <br>
	 * Dieses Ereignis wird ausgeloest bei der User Action: "Cancel" und "OK".
	 * Bei "OK" wird vorher onSet() aufgerufen. Hier also grundsaetzlich die
	 * Einstellungen nicht setzten.
	 */
	public void onDispose();

	/**
	 * Beim Registriern wird, falls vorhanden, der abgespeicherte String, der
	 * die aktuellen Einstellungen fr IPreferences beschreibt, an IPreferences
	 * weitergegeben, damit IPreferences dann diese Einstellungen realisieren
	 * kann.
	 */
	public void onNewSaveString(final String saveString) throws Exception;
}
