/**
 *	May 16, 2007 - May 16, 2007	ws:	creation from scratch
 *	Aug  6, 2009 - Aug 10, 2009	ws:	hunt KiHi Problem now a APrefClientPanel2 not just a APrefClientPanel
 */
package de.desy.mst.libs.framework.mstapp.preferences.examples;

import java.awt.Frame;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JCheckBox;

import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.helper.APrefClientPanel2;

/**
 * Grafische Preferenz Klasse (JPanel und IPrefClient MIT Speichern)
 * <br> Wird bei jeder Grafischen Anzeige frisch erzeugt. Package Privat, da
 * nur PrefOnTop im gleichen Paket diese spezifische Klasse kennen muss (gegen
 * Namensraum-Verschmutzung)
 * @author ws
 * version 1.0.0
 */
 public class PrefClientPanelOnTop extends APrefClientPanel2 {
	private static final long serialVersionUID = 1L;
	private final Frame frame;	//lokale Referenz, aber harmlos
	private JCheckBox jcbAlwaysOnTop;	//pp only for testing
//=============================================================================
	public PrefClientPanelOnTop(final IPrefContainer prefContainer, final Frame frame) {
		super(prefContainer);
		this.frame = frame;
		initialize();
	}
//=============================================================================
	private void initialize() {
		this.setSize(300, 200);
//		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

		initJcbAlwaysOnTop();
		guiFromSystem();
	}
	private void initJcbAlwaysOnTop() {
		final boolean alwaysOnTopSupported = this.frame.isAlwaysOnTopSupported();
		final String warning = 	alwaysOnTopSupported ?
				"" : " Leider unterstuetzt Ihre Platform dieses Feature nicht.";
		this.jcbAlwaysOnTop = new JCheckBox("Das Fenster '"
										  + this.frame.getTitle()
										  + "' immer obenauf zeigen."
										  + warning
		);
		this.jcbAlwaysOnTop.setEnabled(alwaysOnTopSupported);

		this.jcbAlwaysOnTop.addItemListener(new ItemListener() {
			@Override public void itemStateChanged(final ItemEvent e) {
				updateChanged();
			}
		});
		this.add(this.jcbAlwaysOnTop);
	}
//=============================================================================
	@Override public void onDispose() {/*no local reference etc. => no action*/}
	@Override protected void guiToSystem() {
		this.frame.setAlwaysOnTop(this.jcbAlwaysOnTop.isSelected());
	} 
	@Override protected boolean isChanged() {
		return this.jcbAlwaysOnTop.isSelected() != this.frame.isAlwaysOnTop();
	}
	@Override protected void systemToGui() {
		this.jcbAlwaysOnTop.setSelected(this.frame.isAlwaysOnTop());
	}
	@Override public String getSaveString(){
		//Der ganze Zustand (state) wird genau durch eine boolesche Variable
		//beschrieben
		//Encodierung und Dekodierung an einem Ort (Konsistenz leichter zu
		//wahren
		return PrefOnTop.encodeSaveString(this.jcbAlwaysOnTop.isSelected());
	}
//=============================================================================
	/**Gui mit System Werten laden*/
	private void guiFromSystem() {
		this.jcbAlwaysOnTop.setSelected(this.frame.isAlwaysOnTop());
	}
	private void updateChanged() {
		this.getPrefContainer().setChanged(isChanged());
	}
	/**nur zum testen public*/
	public final JCheckBox getJcbAlwaysOnTop() {return this.jcbAlwaysOnTop;}
}
