/**
 * ws:	Feb  9, 2007 - Feb 14, 2007 creation from Basisentwurf von Wst
 *	ws: May 15, 2007 - May 15, 2007	replaced isCheckedForSave() with 
 *											 getSpeicherMode()
 */
package de.desy.mst.libs.framework.mstapp.preferences.helper;

import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.PrefSpeicherMode;

/**
 * IPrefClient als JPanel ohne Speichern von PrefStrings <br>
 * Offen zur Implementation onSet und onReset 
 * @author ws
 * version 1.0.0
 */
public abstract class APrefClientPanelEinfach extends APrefClientPanel {
	private static final long serialVersionUID = 1L;
	
	public APrefClientPanelEinfach(final IPrefContainer prefContainer) {
		super(prefContainer);
	}
	/**Nur fuer den visual editor. Nicht benutzen.*/
	@Deprecated public APrefClientPanelEinfach() {super();}
	
//=============================================================================
	

	/**sollte nie gerufern werden, da keine Persistenz*/
	@Override public final String getSaveString() {
		final String msg = "Einen SaveString angefordert, " +
	                 "obwohl keine Persistenz vorgesehen ist.";
		Logger.SWFW.warn(msg, new IllegalStateException());
		return null;
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.preferences.IPrefClient#getSpeicherMode()
	 */
	@Override public PrefSpeicherMode getSpeicherMode() {
		return PrefSpeicherMode.MEMORYONLY;
	}
}
