/**
 *	Feb 15, 2008 - Feb 15, 2008 ws: added "@Override"es
 */
package de.desy.mst.libs.framework.mstapp.preferences.implementation;

import java.awt.Component;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.util.StringTokenizer;

import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

import de.desy.mst.libs.framework.mstapp.util.gui.GUIFactory;


@SuppressWarnings({"rawtypes"})
public class ComboBoxCellRenderer extends JLabel implements ListCellRenderer {
	/**
	 * 
	 */
	private static final long serialVersionUID = -6653843668543215620L;
	private final int defaultTab=100;
	private FontMetrics fm=null;
	
	public ComboBoxCellRenderer(){
		initialize();
	}
	
	@Override public Component getListCellRendererComponent(final JList list, final Object value,
			final int index, final boolean isSelected, final boolean cellHasFocus) {
			this.setText(value.toString());
		return this;
	}

	@Override public void paintComponent(final Graphics g){
//		super.paintComponent(g);
		final StringTokenizer st= new StringTokenizer(this.getText(),"\t");
//		2 Tokens werden dargestellt:		
		if (st.hasMoreTokens()){
			this.fm=g.getFontMetrics();
			g.setFont(new Font("Dialog",Font.BOLD,12));
			int x=0;
			final int y=this.fm.getAscent();
			String sNext=st.nextToken();
			g.drawString(sNext,x,y);
			if (st.hasMoreTokens()){
				x=x+this.fm.stringWidth(sNext);
				if (x<=this.defaultTab) x=this.defaultTab;
				g.setFont(GUIFactory.createButtonFont());
				sNext=st.nextToken();
				g.drawString(sNext,x,y);
			}	
		}			
	}
	
	private void initialize(){
		
	}
	 
}
