package de.desy.mst.libs.framework.mstapp.preferences.implementation.optionPanels;

import java.awt.Component;
import java.util.StringTokenizer;

import javax.swing.JPanel;

import de.desy.mst.libs.framework.mstapp.MstFrameMain;
import de.desy.mst.libs.framework.mstapp.Screen;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefClient;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.IPreferences;

public class PrefPositionConsole implements IPreferences{
	private JPanel jPanelPreferences=null;
	private IPreferences parent=null;
	private final String title="<html>Programmm-Position und Gre <br>"; 
	private MstFrameMain mainFrame=null;
	private int screenIndex=0;
	
	public PrefPositionConsole(final MstFrameMain mainFrame){
		super();
		this.mainFrame=mainFrame;
	}
	
	@Override public String[] getKeyWords() {
		return new String[]{"Position", "Server"};
	}

	@Override public IPreferences getParent() {
		return this.parent;
	}

	@Override public IPrefClient getPrefClient() {
		Logger.SWFW.info("DebugLevel getPreferenceClient ");		
		return (IPrefClient)this.jPanelPreferences;
	}

	@Override public Component getPrefComponent(final IPrefContainer prefContainer) {
		if (this.jPanelPreferences==null){
				this.jPanelPreferences=new PrefPositionConsolePnl(this
						,prefContainer,this.screenIndex);						
		}
		return this.jPanelPreferences;
	}

	@Override public String getTitle() {
		return this.title;
	}
 
	@Override public void onDispose() {
		Logger.SWFW.info("PrefPosition onDispose ");		
		if (this.jPanelPreferences!=null) {
			this.jPanelPreferences.setVisible(false);
			this.jPanelPreferences = null;	//meine einzige Referenz
		}
	}
	public void setPositionOnScreen(final int index){
		switch (index){
		case 0:
			this.mainFrame.sizeThisForm(Screen.FULL_SCREEN);
			break;
		case 1:
			this.mainFrame.sizeThisForm(Screen.QUARTER.TOP_LEFT);
			break;
		case 2: 
			this.mainFrame.sizeThisForm(Screen.QUARTER.TOP_RIGHT);
			break;
		case 3: 
			this.mainFrame.sizeThisForm(Screen.QUARTER.BOTTOM_LEFT);
			break;
		case 4:
			this.mainFrame.sizeThisForm(Screen.QUARTER.BOTTOM_RIGHT);
			break;
		case 5:
			this.mainFrame.sizeThisForm(Screen.HALF.UPPER);
			break;
		case 6:
			this.mainFrame.sizeThisForm(Screen.HALF.LOWER);
			break;
		case 7:
			this.mainFrame.sizeThisForm(Screen.HALF.LEFT);
			break;
		case 8:
			this.mainFrame.sizeThisForm(Screen.HALF.RIGHT);
			break;
		}
		
	}

	@Override public void setParent(final IPreferences iU) {
		this.parent = iU;
	}

	@Override public void onNewSaveString(final String str) {
		Logger.SWFW.info("PrefPosition onNewPrefString() "+str);		
		final StringTokenizer tokenizer=new StringTokenizer(str,"=");
		if (tokenizer.hasMoreTokens()){
			if (tokenizer.nextToken().equals("PrefPosition")){
				if (tokenizer.hasMoreTokens()){
					try {
						final int index=Integer.parseInt(tokenizer.nextToken());
						Logger.SWFW.info("PrefPosition onNewPrefString() "
																		+index);		
						if (getPrefClient()!=null){
							((PrefPositionConsolePnl)getPrefClient())
															  .setLabels(index);
						}
						this.screenIndex=index;
						setPositionOnScreen(this.screenIndex);
					} catch (final NumberFormatException e) {
						e.printStackTrace();
					}
				}
			}
		
		}
	}
		
}
