/**
 * 
 */
package de.desy.mst.libs.framework.mstapp.server;

import java.awt.Color;


/**
 * @author K. Hinsch -mst1-
 */
public enum ServerState {
	      /**Idle:	    Nr 0*/		IDL("Bereit", Color.BLACK)
		, /**Update:    Nr 1*/		UPDATE("Lese Daten", Color.BLUE)
		, /**Operating: Nr 2*/		OPERATING("Bearbeite Auftrag", Color.RED)
		, /**Busy:      Nr 3*/      BUSY("Bin beschftigt", Color.RED)
		;
//	    -----------------------------------------------------------------------------
	  	private static ServerState serverState = ServerState.IDL;	/**Status des Servers*/
	  	public final String langerName;
	  	public final Color  foreColor;
//	  =============================================================================
		/**@throws NullPointerException, falls mindestens einer der Argumente null ist.*/
		private ServerState(final String langerName, Color foreColor) {
			if(langerName  == null){throw new NullPointerException("Der lange Name kann nicht null sein.");}
			this.langerName  = langerName;
			this.foreColor  =  foreColor;
		}
//	=============================================================================	  	
		/**ServerState dieser Applikation, nie null*/
		public static final ServerState getServerState() {return serverState;}
		/**ServerState dieser Applikation @throws NullPointerException*/
		public static final void setServerState(ServerState serverState) {
			if(serverState == null){throw new NullPointerException("Der Serverstatus kann nicht null sein.");}
			ServerState.serverState = serverState;
		}
		/**Nimmt das Framework falls nicht anders gesetzt.*/
		public static ServerState getDefaultState() {return ServerState.IDL;}
		public final String getLangenNamen() {return this.langerName;}
		public final Color getForeColor() {return this.foreColor;}
}
