/**
 *  Created on	May 26, 2006 - May 26, 2006 from Trim
 */
package de.desy.mst.libs.framework.mstapp.tabellendaten.devices;

import de.desy.mst.libs.framework.mstapp.mode.Betrieb;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.AEntry;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.SedacDevice;

/**
 * Sedac Device Klasse fuer kh
 * @author ws
 * @version 1.0.0
 */
public class Lage	extends 	SedacDevice{
	public final int		devType;	
	public final Betrieb	betrieb;
	public final int		addCr;
	public final int		addSu;
	public final double		kon_x;
	public final double		kon_z;
	public final double		delko_x;
	public final double		delko_z;
	public final int		uml_Cr;
	public final int		uml_Su;
	public final int		uml_Fak;
	public final int		plKorr;
	
//=============================================================================
	
	/**Signatur nicht aendern, gehoert zu stored Procedure 'devLageVerzXML0'*/
	public Lage(final int    devGrNr,	final int devNo,	final String devName
			  , final int      sedLn, 	final int sedCr,	final int    sedSu
			  , final int    devType,	final String betriebsName
			  ,	final int      addCr,	final int addSu	
			  ,	final double   kon_x,	final double kon_z	
			  ,	final double   delko_x,	final double delko_z	
			  , final int      uml_Cr, 	final int uml_Su,	final int    uml_Fak
			  , final int 	   plKorr
			   ) {
		
		super(devGrNr, devNo, devName, sedLn, sedCr, sedSu);
		this.devType	= devType;
		this.betrieb	= Betrieb.getByName(betriebsName);
		this.addCr		= addCr;
		this.addSu		= addSu;
		this.kon_x		= kon_x;
		this.kon_z		= kon_z;	
		this.delko_x	= delko_x;
		this.delko_z	= delko_z;	
		this.uml_Cr		= uml_Cr;
		this.uml_Su		= uml_Su;
		this.uml_Fak	= uml_Fak;
		this.plKorr		= plKorr;
		
	}
	
	public Lage(final int    devGrNr,	final int devNo,	final String devName
			  , final int      sedLn, 	final int sedCr,	final int    sedSu
			  , final int    devType,	final String betriebsName
			  ,	final int      addCr,	final int addSu	
			  ,	final double   kon_x,	final double kon_z	
			  ,	final double   delko_x,	final double delko_z	
			  , final int      uml_Cr, 	final int uml_Su,	final int    uml_Fak
			  , final int 	   plKorr
			  , final Object ... unsupportedExtraParams
			   ) {
		this(devGrNr, devNo, devName, sedLn, sedCr, sedSu
		   , devType, betriebsName, addCr, addSu
		   , kon_x, kon_z, delko_x, delko_z, uml_Cr, uml_Su, uml_Fak, plKorr
		     );
		handleUnsupportedExtraParams(this, unsupportedExtraParams); 
	}
	

	//public Lage(){this(1,2,"ONLY FOR TESTING", 3,4,5, 11,22,33,4.4,"DummyExtZyk");}
//=============================================================================
	
	//public final void setDevGrNr(int 	devGrNr){;}
	//public final void setDevNo	(int 	devNo)	{;}
	//public final void setDevName(String devName){;}
	//public final void setSedLn	(int 	sedLn)	{;}
	//public final void setSedCr	(int 	sedCr)	{;}
	//public final void setSedSu	(int 	sedSu)	{;}
	//public final void setCo1	(int 	co1) 	{this.co1 		= co1;}
	//public final void setCo2	(double	co2) 	{this.co2		= co2;}
	//public final void setDevType(int 	devType){this.devType	= devType;}
	//public final void setExtZyk	(String	extZyk)	{this.extZyk 	= extZyk;}
	//public final void setInit(int init) 		{this.init = init;}


	@Override public boolean inSeinenWertenGleich(final AEntry<Integer> otherEntry) {
		if(!(otherEntry instanceof Lage)) {return false;}
		final Lage other = (Lage) otherEntry;
		return super.inSeinenWertenGleich(otherEntry)
			&& this.devType	== other.devType	
			&& this.betrieb	== other.betrieb
			&& this.addCr	== other.addCr
			&& this.addSu	== other.addSu
			&& this.kon_x	== other.kon_x
			&& this.kon_z	== other.kon_z
			&& this.delko_x	== other.delko_x 
			&& this.delko_z	== other.delko_z
			&& this.uml_Cr	== other.uml_Cr
			&& this.uml_Su	== other.uml_Su
			&& this.uml_Fak	== other.uml_Fak
			&& this.plKorr	== other.plKorr
			;
	}

//=============================================================================
	
	public final int 	getAddCr() 	{return this.addCr;}
	public final int 	getAddSu() 	{return this.addSu;}
	public final Betrieb getBetrieb(){return this.betrieb;}
	public final double getDelko_x(){return this.delko_x;}
	public final double getDelko_z(){return this.delko_z;}
	public final int 	getDevType(){return this.devType;}
	public final double getKon_x() 	{return this.kon_x;}
	public final double getKon_z() 	{return this.kon_z;}
	public final int 	getPlKorr() {return this.plKorr;}
	public final int 	getUml_Cr() {return this.uml_Cr;}
	public final int 	getUml_Fak(){return this.uml_Fak;}
	public final int 	getUml_Su() {return this.uml_Su;}
}
