//20170904	ws	fixed trivial warnings


package de.desy.mst.libs.framework.mstapp.util.gui;

import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.control.Button;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.input.MouseEvent;
import javafx.util.Duration;

public class IndicatorButtonFx extends Button {
	private Timeline tline = null;
	private double seconds;
	private ImageView oldImageView = null;
	private boolean onAction;
	public static Image IMAGE_BLUE ;
	public static Image IMAGE_BLACK;
	private Image image = null;
	private boolean startStopAutomatic = true;
	/**Default Kontruktor: Ohne Parameter erzeugen.*/
	public IndicatorButtonFx(){
		initialize();
	}
	/**Konstruktor mit Text: Text fuer den Button.*/
	public IndicatorButtonFx(final String text){
		this.setText(text);
		initialize();
	}
	/**Konstruktor mit Sekunden: Sekunden fuer die TimeLine.*/
	public IndicatorButtonFx(final double seconds){
		this.seconds = seconds;
		initialize();
	}
	/**Konstruktor mit Text und Sekunden:*/
	/**
	 * 
	 * @param text fuer den Button
	 * @param seconds fuer die TimLine
	 */
	public IndicatorButtonFx(final String text,final double seconds){
		this.setText(text);
		this.seconds = seconds;
		initialize();
	}
	private void initialize(){
		IMAGE_BLUE = new Image(getClass().getResourceAsStream("/resources/indicatorbutton/progress_16x16_blue.gif"));
		IMAGE_BLACK = new Image(getClass().getResourceAsStream("/resources/indicatorbutton/progress_16x16_black.gif"));
		this.image = IMAGE_BLACK;
	    this.tline = new Timeline(new KeyFrame(Duration.seconds(this.seconds), new EventHandler<ActionEvent>() {
	        @Override
	        public void handle(final ActionEvent event) {
//	            setOnAction(false);
				stop();
	        }
	    }));
        this.setOnMouseClicked(new EventHandler<MouseEvent>()
        {
            @Override
            public void handle(final MouseEvent event)
            {
				if(IndicatorButtonFx.this.startStopAutomatic){
					if(!IndicatorButtonFx.this.onAction){start();}
				}
            }
        });
	}
	/** 
	 * 
	 * @return
	 */
	public Timeline getTline() {
		return this.tline;
	}
	/**
	 * 
	 * @param tline
	 */
	public void setTline(final Timeline tline) {
		this.tline = tline;
	}
	/**
	 * 
	 * @return
	 */
	public double getDelay() {
		return this.tline.getDelay().toSeconds();
	}
	/**
	 * 
	 * @param seconds
	 */
	public void setDelay(final double seconds) {
		this.seconds = seconds;
		this.tline.setDelay(new Duration(seconds));
	}
	/**
	 * Starten des Timers
	 */
	public void start(){
		setOnAction(true);
		this.tline.play();
	}
	/**
	 * Stoppen des Timers
	 */
	public void stop(){
		this.tline.stop();
		setOnAction(false);
	}
	/**
	 * Button setDisable(b)
	 * ProgressIndicator setVisible(b)
	 * @param b
	 */
	public void setOnAction(final boolean b){
		this.onAction = b;
		this.setDisabled(b);
		if(b){
			this.oldImageView = (ImageView)this.getGraphic();
			this.setGraphic(new ImageView(this.image));
		}else{
			this.setGraphic(this.oldImageView);
		}
	}
	/**
	 * wird der Handler gerade abgearbeitet?
	 * @return
	 */
	public boolean isOnAction(){
		return this.onAction;
	}
	public Image getAnimatedImage(){
		return this.image;
	}
	public void setAnimatedIcon(final Image image){
		this.image = image;
	}
	public boolean isStartStopAutomatic() {
		return this.startStopAutomatic;
	}
	public void setStartStopAutomatic(final boolean startStopAutomatic) {
		this.startStopAutomatic = startStopAutomatic;
	}

}
