//20170904	ws	fixed trivial warnings

package de.desy.mst.libs.framework.mstapp.util.gui;

import java.awt.Image;
import java.awt.event.MouseListener;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.Timer;

public class JIndicatorButton extends JButton {
	private static final long serialVersionUID = 1L;
	private Timer tline = null;
	private int seconds;
	private boolean onAction;
	public static Icon ICON_BLUE ;
	public static Icon ICON_BLACK;
//	private static Icon ENABLED_EMPTY;
	Icon icon = null;
	Icon oldIcon = null;
	private boolean startStopAutomatic = true;
//	private Icon oldDisabledIcon;
	/**Default Kontruktor: Ohne Parameter erzeugen.*/
	public JIndicatorButton(){
		initialize();
	}
	/**Konstruktor mit Text: Text fuer den Button.*/
	public JIndicatorButton(final String text){
		this.setText(text);
		initialize();
	}
	/**Konstruktor mit Delay: InitialDelay fuer den Timer.*/
	public JIndicatorButton(final int seconds){
		this.seconds = seconds;
		initialize();
	}
	/**Konstruktor mit Text und Delay:*/
	/**
	 * 
	 * @param text fuer den Button
	 * @param delay fuer den Timer
	 */
	public JIndicatorButton(final String text,final int seconds){
		this.setText(text);
		this.seconds = seconds;
		initialize();
	}
	private void initialize(){
		ICON_BLUE = new ImageIcon(getClass().getResource("/resources/indicatorbutton/progress_16x16_blue.gif"));
		ICON_BLACK = new ImageIcon(getClass().getResource("/resources/indicatorbutton/progress_16x16_black.gif"));
//		ENABLED_EMPTY = new ImageIcon(getClass().getResource("/resources/indicatorbutton/ICON_EMPTY_16x16.PNG"));
		this.icon = setEnabledIcon(ICON_BLACK);
		setHorizontalTextPosition(0);
//		setWaitDisabledIcon(ICON_BLACK);
//		oldDisabledIcon = ICON_BLACK;
		this.tline = new Timer(this.seconds, new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(final java.awt.event.ActionEvent e) {
//				setOnAction(false);
				stop();

			}
		});
		this.tline.setInitialDelay(this.seconds * 1000);
		this.tline.setDelay(this.seconds * 1000);
		this.tline.stop();
		this.addMouseListener(new MouseListener() {
			
			@Override
			public void mouseReleased(final java.awt.event.MouseEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void mousePressed(final java.awt.event.MouseEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void mouseExited(final java.awt.event.MouseEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void mouseEntered(final java.awt.event.MouseEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void mouseClicked(final java.awt.event.MouseEvent e) {
				if(JIndicatorButton.this.startStopAutomatic){
					if(!JIndicatorButton.this.onAction){start();}
				}
				
			}
		});
	}
	private Icon setEnabledIcon(Icon icon){
        int height = getHeight() > 0 ? (int)(getHeight() * 0.7) : 16;
        int width = getWidth() > 0 ? (int)(getWidth() * 0.7) : 16;
        if (icon instanceof ImageIcon) {
            if (width <= 0) width = 1;
            icon = new ImageIcon(((ImageIcon)icon).getImage().getScaledInstance(width,-1,Image.SCALE_FAST));
            if (icon.getIconHeight() > height) {
                if (height <= 0) height = 1;
                icon = new ImageIcon(((ImageIcon)icon).getImage().getScaledInstance(-1,height,Image.SCALE_FAST));
            }
        }
        
        return icon;
    }
//	private void setWaitDisabledIcon(Icon icon){
//        int height = getHeight() > 0 ? (int)(getHeight() * 0.7) : 16;
//        int width = getWidth() > 0 ? (int)(getWidth() * 0.7) : 16;
//        if (icon instanceof ImageIcon) {
//            if (width <= 0) width = 1;
//            icon = new ImageIcon(((ImageIcon)icon).getImage().getScaledInstance(width,-1,Image.SCALE_FAST));
//            if (icon.getIconHeight() > height) {
//                if (height <= 0) height = 1;
//                icon = new ImageIcon(((ImageIcon)icon).getImage().getScaledInstance(-1,height,Image.SCALE_FAST));
//            }
//        }
//        this.setDisabledIcon(icon);
//    }
	/**
	 * 
	 * @return
	 */
	public Timer getTline() {
		return this.tline;
	}
	/**
	 * 
	 * @param tline
	 */
	public void setTline(final Timer tline) {
		this.tline = tline;
	}
	/**
	 * 
	 * @return
	 */
	public double getDelay() {
		return (double)this.tline.getInitialDelay() / (double)1000;
	}
	/**
	 * 
	 * @param seconds
	 */
	public void setDelay(final int seconds) {
		this.seconds = seconds;
		this.tline.setInitialDelay(seconds * 1000);
		this.tline.setDelay(seconds * 1000);
	}
	/**
	 * Starten des Timers
	 */
	public void start(){
		setOnAction(true);
		this.tline.start();
//		setWaitDisabledIcon(oldDisabledIcon);
	}
	/**
	 * Stoppen des Timers
	 */
	public void stop(){
		this.tline.stop();
		setOnAction(false);
//		oldDisabledIcon = this.getDisabledIcon();
//		setWaitDisabledIcon(null);
	}
	/**
	 * Button setDisable(b)
	 * ProgressIndicator setVisible(b)
	 * @param b
	 */
	public void setOnAction(final boolean b){
		this.onAction = b;
		this.setEnabled(!b);
		if(b){
			this.oldIcon = this.getIcon();
			this.setIcon(this.icon);
		}else{ 
			this.setIcon(this.oldIcon);
		}
	}
	/**
	 * wird der Handler gerade abgearbeitet?
	 * @return
	 */
	public boolean isOnAction(){
		return this.onAction;
	}
	public Icon getAnimatedIcon(){
		return this.icon;
	}
	public void setAnimatedIcon(final Icon icon){
		this.icon = icon;
	}
	@Override
	public void setIcon(final Icon defaultIcon){
		if(defaultIcon == null){
			this.setHorizontalTextPosition(0);
		}else{
			this.setHorizontalTextPosition(11);
		}
		super.setIcon(setEnabledIcon(defaultIcon));
	}
	public boolean isStartStopAutomatic() {
		return this.startStopAutomatic;
	}
	public void setStartStopAutomatic(final boolean startStopAutomatic) {
		this.startStopAutomatic = startStopAutomatic;
	}
}
