/**
 * 	Jul 14, 2010 - Jul 14, 2010	ws:	created from scratch
 */
package de.desy.mst.libs.info.appadmin;

/**
 * _APipeFromTo will be called via its interface _IMsgListener<FM>(From Message)
 * and will call _IMsgListener<TM> (ToMessage) with a transformed value.
 * <br>Nulls will be ignored and not transported.
 * @author ws
 */
abstract class _ATransform<FM, TM> implements _IMsgListener<FM>{
	private final _IMsgListener<TM> to;

	/**@throws NullPointerException*/
	public _ATransform(final _IMsgListener<TM> to) {
		__Utils.checkForNull(to, "to");
		this.to = to;
	}
	
	abstract TM transform(final FM fromMsg);
	
	public final void onMessage(final FM fromMsg) {
		final TM toMessage = transform(fromMsg);
		if(toMessage != null)
			getTo().onMessage(toMessage);
	}
	
	private final _IMsgListener<TM> getTo  () {return this.to;}
}


