/**
 * 	Jul 15, 2010 - Jul 15, 2010	ws:	created from AppAdmin.UpdateNotification
 */
package de.desy.mst.libs.info.appadmin;

import static de.desy.mst.libs.info.appadmin._SystemEntry.UPDATE_NOTIFICATION;

import de.desy.mst.libs.info.appadmin.AppAdmin.IUpdateCallBack;

/**
 * @author ws
 */
class _UpdateNotification implements AppAdmin.IUpdateNotification{
	public static final String FILTER = UPDATE_NOTIFICATION.getJMSFilter();
//=============================================================================	
	private final _UpdateNotificationEmitter     emitter;
	private final _IUpdateCallBackEDTMulticaster receiver;
	private final _IInternalMsgListener internalMsgListener;
	
	//.....................................................................
	
//	_UpdateNotification(final _Queue queue, final _IInternalMsgListener internalMsgLst) {
//		this.emitter  = new _UpdateNotificationEmitter(queue);
//		this.receiver = new _IUpdateCallBackEDTMulticaster();
//		connectToJMSTopic(createJMSMsgReceiver(createInternalMsgListener()));
//	}
//	_UpdateNotification(final _Queue queue, final _IJMSMsgListener jmsMsgListener) {
//		this.emitter  = new _UpdateNotificationEmitter(queue);
//		this.receiver = new _IUpdateCallBackEDTMulticaster();
//		connectToJMSTopic(jmsMsgListener); 
//	}
	_UpdateNotification(final _Queue queue) {
		this.emitter  = new _UpdateNotificationEmitter(queue);
		this.receiver = new _IUpdateCallBackEDTMulticaster();
		this.internalMsgListener = createInternalMsgListener();
	}
	
	//.....................................................................

	/**A new update is published*/
	public final void fireNewUpdate(final String name){
		getEmitter().fireNewUpdate(name);
	}
	/**register for update notification*/
	public final void register(final AppAdmin.IUpdateCallBack cb){
		getReceiver().register(cb);
	}
	/**deregister for update notification*/
	public final void deregister(final AppAdmin.IUpdateCallBack cb){
		getReceiver().unregister(cb);
	}
	public boolean isRegistered(final Object cb){
		return getReceiver().isRegistered(cb);
	}
	
	//.....................................................................
	
	final _IJMSMsgListener createJMSMsgListener() {
		return new _JMS2InternalMsg(getInternalMsgListener());
	}
	final _IInternalMsgListener getInternalMsgListener() {
		return this.internalMsgListener;
	}
	final void connectToJMSTopic() {
		getContext().createDefaultReaderJMSTopic(createJMSMsgListener(), FILTER);
	}
	//.....................................................................
	
	private final _UpdateNotificationEmitter     getEmitter () {return this.emitter ;}
	private final _IUpdateCallBackEDTMulticaster getReceiver() {return this.receiver;}
	private IUpdateCallBack getMulticastReceiver() {
		return getReceiver().getMulticastReceiver();
	}

	private _IInternalMsgListener createInternalMsgListener() {
		return new _BlockTestMsg(new _InternalMsg2UpdateName(getMulticastReceiver()));
	}

	private AppAdminContext getContext() {return AppAdminContext.getInstance();}
}
