/**
 * 
 * Last changed: $Date$
 * By: $Author$
 * URL: $HeadURL$
 * $Revision$ 
 *
 */
package de.desy.mst.libs.pintlk.badgerviewer.network;

import de.desy.mst.libs.framework.mstapp.util.gui.AppColor;




/**
 * @author labudda
 *
 */
public class DachsEntry {
	private final static java.text.SimpleDateFormat dateFormat = new java.text.SimpleDateFormat("HH:mm");
	private final static AppColor DENY = new AppColor("deny", java.awt.Color.WHITE, java.awt.Color.RED); 
	private final String personName;
	private final long timeStamp;
	private final boolean granted;
	private final boolean isError; 

	public DachsEntry(String errorText) {
		this.personName = errorText;
		this.isError = true;
		this.timeStamp = System.currentTimeMillis();
		this.granted = false;
	}

	/**
	 * @param personName - text of acquisition
	 * @param timeStamp
	 * @param granted
	 */
	public DachsEntry(String personName, double timeStamp, double granted) {
		this.personName = personName;
		this.timeStamp = (long) timeStamp;
		this.granted = granted != 0d;
		this.isError = true;
	}

	public String getText(){
		final java.util.TimeZone tz = java.util.TimeZone.getDefault();
		final java.util.Calendar date = java.util.Calendar.getInstance(tz);
		date.setTimeInMillis(this.timeStamp);
		
		final StringBuffer text = new StringBuffer();
		if (this.timeStamp <= 0) {
			text.append("--:--");
		} else {
			text.append(DachsEntry.dateFormat.format(date.getTime()));
		}
		text.append(" > ");
		text.append(personName);
		if (this.granted || this.isError) {
			text.append("");
		} else {
			text.append(" VERWEIGERT");
		}
		return text.toString();
	}


	/**
	 * Defineirt die Farben der Komponenente, abhaengig vom Zustand des DachsEntries
	 * @param component
	 */
	public void decorate(java.awt.Component component) {
		if (this.granted) {
			AppColor._EIN_UND_OK.set(component);
		} else {
			DachsEntry.DENY.set(component);
		}
	}
	
	
}
