package de.desy.mst.libs.pintlk.badgerviewer.network;





/** Vereinheitlicht die Verwaltung verschiedener Links aud die Server
 * @author labudda
 *
 */
public interface IServersClient {

	/** - Hier wird der Server eines Clients definiert
	 * - Der Server kann sich waehrend der Lebenszeit des Client aendern. 
	 * Entsprechend muessen vorhandene Links geschlossen werden, wenn ein Server definiert wird.
	 * - Ist der Parameter null, soll die Serverbindung geschlossen werden, ohne eine neue zu eroeffnen.
	 * - Erzeugt der Verbindungsaufbau einen Fehler ist es Aufgabe des Objektes ihn zu behandeln.
	 * - RuntimeExceptins soll vom Objekt an den zentralen 'BugManager' gemeldet werden.
	 * Tine Laufzeitfehler ist u.A. "unbekannter Name". D.h. der Nameserver kennt den Servernamen nicht.
	 * Solche Fehler werden scheinbar ber RuntimeException signlisiert.
	 * Solche Fehler sind schwerwiegender als "Link Pending" d.h. es wird kein weiterer Verbindungsversuch zum Deviceserver unternommen     
	 * Solch ein Fehler definitiv nicht innerhalb Tine behoben werden. 
	 * 
	 * @param serverConnectionDecription    Sets the nae of the tine Server including
	 * the tine context
	 */
	public void setConnectionParameter(TineParameter serverConnectionDecription) throws RuntimeException;
}





