/*
 * Created on May 27, 2009
 *
  */
package de.desy.mst.libs.ser.tclientlib.connection;

public interface IObservableConnection {
    
    /**
     * Returns true if the connection is established and receives data.
     * 
     * This means that the connection has been opened successfully,
     * has no failure and is actually receiving data.
     */
    public boolean isDataAvailable();
    
    /**
     * Returns true if the connection is failed.
     * This means that the connection could not be opened
     * or a connection error has occurred.
     */
    public boolean hasError();
    
    /**
     * Closes the connection.
     */
    public void closeConnection();
    
    /**
     * Opens the connection.
     */
    public boolean openConnection();
    
    /**
     * Checks if opening the connection is possible.
     * This may prevent clients from calling openConnection()
     * when it's impossible anyway.
     */
    public boolean isConnectionPossible();
    

    
}
