/*
 * Created on May 28, 2009
 *
  */
package de.desy.mst.libs.ser.tclientlib.connection;

/**
 * A counter that increments a value.
 * Ensures that the value is always positive.
 */
public class StatisticsCounter {

    long value = 0;
    
    /**
     * Increments the value.
     * Sets the value to 0 when a number overflow occurs.
     */
    public void increment() {
        value++;
        if (value < 0) value = 0;
    }

    /**
     * Returns the value.
     */
    public long getValue() {
        return value;
    }
    
    /**
     * Resets the value to 0.
     */
    public void reset() {
        value = 0;
    }

}
