package de.desy.tine.definitions;

/**
 * TINE Static error strings
 */
public class TErrorList
{
  public static final int CE_REDIRECTED = 0x8000;
  public static final int CE_SENDDATA = 0x4000;
  public static final int CE_RENEGOTIATE = 0x2000;
  public static final int ERROR_SIZE = 32;
  public static final short status_pending = -1;
  public static final short success = 0;
  public static final short illegal_line = 1;
  public static final short illegal_format = 2;
  public static final short illegal_arithmetic = 3;
  public static final short ambiguous = 4;
  public static final short illegal_delimiter = 5;
  public static final short zero_divide = 6;
  public static final short WA_full = 7;
  public static final short non_existent = 8;
  public static final short invalid_transport = 9;
  public static final short data_size_mismatch = 10;
  public static final short no_data_in_range = 11;
  public static final short un_allocated = 12;
  public static final short no_such_line = 13;
  public static final short illegal_data_size = 14;
  public static final short io_error = 15;
  public static final short illegal_context = 16;
  public static final short runtime_error = 17;
  public static final short system_error = 18;
  public static final short hardware_busy = 19;
  public static final short argument_list_error = 20;
  public static final short invalid_parameter = 20;
  public static final short file_error = 21;
  public static final short use_stream_transport = 22;
  public static final short dimension_error = 23;
  public static final short square_root_negative = 24;
  public static final short buffer_too_small = 25;
  public static final short string_too_long = 26;
  public static final short ipx_socket_error = 27;
  public static final short net_read_error = 28;
  public static final short not_ready = 29;
  public static final short invalid_transport_size = 30;
  public static final short log_negative = 31; /* or = 0 */
  public static final short device_not_connected = 32;
  public static final short unauthorised_action = 33;
  public static final short hardware_error = 34;
  public static final short illegal_equipment_number = 35;
  public static final short illegal_device_number = 35;
  public static final short illegal_device = 35;
  public static final short illegal_property = 36;
  public static final short out_of_range = 37;
  public static final short not_implemented = 38;
  public static final short no_such_computer = 39;
  public static final short struct_sealed = 40;
  public static final short syntax_error = 41;
  public static final short no_such_file = 42;
  public static final short file_already_exists = 43;
  public static final short no_file_space = 44;
  public static final short link_not_open = 45;
  public static final short link_timeout = 45;
  public static final short remitted_data_lost = 46;
  public static final short end_of_file = 47;
  public static final short archive_busy = 48;
  public static final short server_name_in_use = 49;
  public static final short no_such_column = 50;
  public static final short out_of_client_memory = 51;
  public static final short mcast_access_required = 52;
  public static final short address_unresolved = 53;
  public static final short invalid_property = 54;
  public static final short address_unknown = 55;
  public static final short name_unknown = 56;
  public static final short invalid_keyword = 57; 
  public static final short invalid_link = 58; 
  public static final short string_expected = 59;
  public static final short out_of_local_memory = 60;
  public static final short out_of_shared_memory = 61;
  public static final short invalid_structure_tag = 62;
  public static final short invalid_index = 63;
  public static final short illegal_equipment_name = 64;
  public static final short link_error = 65;
  public static final short code_failure = 66;
  public static final short non_existent_server = 67;
  public static final short deprecated = 68;
  public static final short function_deprecated = 68;
  public static final short not_supported = 69;
  public static final short illegal_character = 70;
  public static final short parsing_error = 70;
  public static final short illegal_operator = 71;
  public static final short not_allowed = 72;
  public static final short illegal_read_write = 73;
  public static final short out_of_server_memory = 74;
  public static final short database_not_loaded = 75;
  public static final short illegal_command = 76;
  public static final short resources_exhausted = 77;
  public static final short file_not_open = 78;
  public static final short sedac_error = 79; /* sedac */
  public static final short reacquire_address = 80; 
  public static final short semaphore_error = 81;
  public static final short driver_not_installed = 82;
  public static final short port_not_available = 83;
  public static final short async_access_required = 84;
  public static final short semaphore_busy = 85;
  public static final short non_existent_elem = 86;
  public static final short non_existent_fec = 87;
  public static final short non_existent_client = 88;
  public static final short cannot_lock = 89;
  public static final short not_running = 90;
  public static final short not_posted = 91;
  public static final short not_accepted = 92;
  public static final short operation_timeout = 93;
  public static final short illegal_protocol = 94;
  public static final short gpib_error = 95;
  public static final short rs232_error = 96;
  public static final short operation_busy = 97;
  public static final short connection_timeout = 98;
  public static final short illegal_mode = 99;
  public static final short not_owner = 100;
  public static final short not_defined = 101;
  public static final short net_write_error = 102;
  public static final short invalid_data = 103;
  public static final short software_error = 104;
  public static final short access_denied = 105;
  public static final short tcp_not_supported = 106;
  public static final short ipx_not_supported = 107;
  public static final short host_not_resolved = 108;
  public static final short tcp_connect_error = 109;
  public static final short tcp_socket_error = 110;
  public static final short configuration_error = 111;
  public static final short invalid_return_code = 112;
  public static final short link_blacklisted = 113;
  public static final short link_exists = 114;
  public static final short max_alarms_exceeded = 115;
  public static final short not_exported = 116;
  public static final short is_switching = 117;
  public static final short at_limit = 118;
  public static final short get_subscription_id = 119;
  public static final short renegotiate_contract = 120;
  public static final short server_redirection = 121;
  public static final short value_too_high = 122;
  public static final short value_too_low = 123;
  public static final short warn_too_high = 124;
  public static final short warn_too_low = 125;
  public static final short completion_waiting = 126;
  public static final short cannot_select = 127;
  public static final short has_query_function = 128;
  public static final short not_signalled = 129;
  public static final short call_redirection = 130;
  public static final short udp_socket_error = 131;
  public static final short mutex_error = 132;
  public static final short data_not_local = 133;
  public static final short name_already_exists = 134;
  public static final short already_assigned = 135;
  public static final short invalid_field = 136;
  public static final short mcast_init_error = 137;
  public static final short invalid_mcast_group = 138;
  public static final short non_existent_function = 139;
  public static final short property_is_mca = 140;
  public static final short invalid_name = 141;
  public static final short invalid_value = 142;
  public static final short device_error = 143;
  public static final short device_not_ready = 144;
  public static final short device_busy = 145;
  public static final short invalid_interval = 146;
  public static final short notification_pending = 147;
  public static final short thread_error = 148;
  public static final short is_terminating = 149;
  public static final short name_server_unknown = 150;
  public static final short lock_required = 151; 
  public static final short not_initialized = 152; 
  public static final short invalid_structure_size = 153; 
  public static final short canbus_error = 154; 
  public static final short profibus_error = 155; 
  public static final short data_stale = 156;
  public static final short has_bitfield_tag = 157;
  public static final short not_locked = 158;
  public static final short lock_expired = 159;
  public static final short not_registered = 160;
  public static final short non_existent_property = 161;
  public static final short memory_overwrite = 162;
  public static final short server_idle = 163;
  public static final short not_applicable = 164;
  public static final short access_locked = 165;
  public static final short invalid_reference = 166;
  public static final short has_structure_tag = 167;
  public static final short warn_disk_space = 168;
  public static final short low_disk_space = 169;
  public static final short information_static = 170;
  public static final short reset_mca_property = 171;
  public static final short record_too_long = 172;
  public static final short unix_socket_error = 173;
  public static final short pipe_error = 173;
  public static final short shm_error = 174;
  public static final short tcp_connection_closed = 175;
  public static final short service_unavailable = 176;
  public static final short device_offline = 177;
  public static final short out_of_sequence = 178;
  public static final short invalid_datarequest = 179;
  public static final short property_is_mca_elevated = 180;
  public static final short name_not_found = 181;
  public static final short out_of_tolerance = 182;

  public static String[] errorString = {"success", "illegal line number", "illegal format specification",
      "illegal arithmetic expression", "ambiguous command", "illegal delimiter", "attempt to divide by zero",
      "working area full", "nonexistent name", "invalid transport medium", "data_size_mismatch",
      "no data found in range", "not allocated", "nonexistent line addressed", "illegal data size",
      "i/o error", "illegal context", "runtime error", "system error",
      "hardware operation in progress", "parameter error", "file error", "resort to stream transport",
      "array dimension error", "square root of neg.number", "data buffer too small", "string too long",
      "ipx socket error", "net read error", "call not ready", "invalid transport size",
      "logarithm argument <= 0", "device not connected", "unauthorised action", "hardware error",
      "illegal device", "illegal property", "value out of range", "not implemented yet",
      "no such computer", "tagged struct is sealed", "syntax error", "no such file", "file already exists",
      "no file space", "link timeout", "remitted data lost", "end of file", "archive in progress",
      "server name in use", "no such column", "out of client memory", "network access required",
      "address unresolved", "invalid or missing property", "address unknown",
      "name unknown", "invalid keyword", "invalid link handle", "String expected",
      "out of local memory", "out of shared memory", "invalid structure tag", "invalid index",
      "illegal equipment name", "link error", "code failure", "nonexistent server",
      "function deprecated", "not supported", "parsing error", "illegal relational operator",
      "not allowed", "illegal read/write attempted", "out of server memory",
      "database not loaded", "illegal command", "resources exhausted", "file not open", "SEDAC error",
      "reacquire address", "semaphore error", "driver not installed", "COMx port_not_available",
      "asynchronous access required", "semaphore blocked", "nonexistent Element", "nonexistent Fec", "nonexistent Client",
      "unable to lock memory", "server not responding", "result not posted", "command not accepted",
      "operation timeout", "Illegal network protocol", "gpib error", "rs232 error", "operation busy",
      "connection timeout", "illegal mode", "not owner", "not defined", "net write error", "invalid data",
      "software error", "access denied", "tcp not supported", "ipx not supported", "host not resolved",
      "tcp connect error", "tcp socket error", "configuration error", "invalid return code", "link is blacklisted", "link exists",
      "alarms buffer full", "not exported", "is switching", "at limit", "get subscription id",
      "renegotiate contract", "server redirection", "value too high", "value too low", "warn too high",
      "warn too low", "wait for completion", "cannot select", "has query function", "not signalled",
      "call redirection", "udp socket error", "mutex error", "data not local", "name already exists",
      "already assigned", "invalid field", "multicast init error", "invalid multicast group",
      "nonexistent function", "use channel array", "invalid name", "invalid value", "device_error",
      "device not ready", "device busy", "invalid time interval", "notification pending", "thread error",
      "process is terminating", "name server unknown", "access lock required", "not initialized", 
      "invalid structure size","canbus error","profibus error","data stale","has bitfield tag",
      "not locked","lock expired","not registered","nonexistent property","memory overwrite",
      "server idle","not applicable", "access locked", "invalid data reference",
      "has structure tag", "disk space is low", "disk space is very low","information is static",
      "reset mca property", "record too long", "unix socket or pipe error", "shared memory error",
      "tcp connection closed", "service unavailable", "device offline", "out of sequence", "invalid data request",
      "use elevated channel array", "name not found", "out of tolerance"
};
  public TErrorList()
  {
    super();
  }
  public static boolean isBlackListOffense(int code)
  {
      switch (code)
      {
        case illegal_property:
        case non_existent:
        case non_existent_elem:
        case non_existent_fec:
          return true;
        default:
          break;
      }
      return false;  
  }
  public static boolean isSystemInternal(int code)
  {
    switch (code)
    {
      case call_redirection:
      case server_redirection:
      case invalid_interval:
      case invalid_datarequest:
      case illegal_protocol:
      case get_subscription_id:
      case mcast_access_required:
      case has_structure_tag:
      case has_bitfield_tag:
      case property_is_mca:
      case property_is_mca_elevated:
        return true;
      default:
        break;
    }
    return false;
  }
  public static boolean isMcaPropertyCoercive(int code)
  {
    switch (code)
    {
      case property_is_mca:
      case property_is_mca_elevated:
        return true;
      default:
        break;
    }
    return false;
  
  }
  /**
   * Removes informational bits from the given error code
   * @param code is the tine error code for which the undecorated error code is desired
   */
  public static int getErrorCode(int code)
  {
    if (code == -1) return -1;
    code &= 0x0fff;
    return code;
  }
  /**
   * Interprets system error code as string
   * @param code is the tine error code for which the error string is desired
   */
  public static String getErrorString(int code)
  {
    if (code == -1)return new String("link status not available (link pending)");
    code &= 0x0fff;
    if (isSystemInternal(code))
    {
      new String("link status not available ("+errorString[code].trim()+" pending)");
    }
    if (code >= 0 && code < errorString.length)
      return errorString[code].trim();
    else
      return new String("Error " + code + " undefined");
  }
  /**
   * Interprets system error code as string
   * @param code is the tine error code for which the error string is desired
   */
  public static String toString(int code)
  {
    return getErrorString(code);
  }
  /**
   * Determines whether the given status (return) code also implies that
   * data have been returned in the call
   * @param code is the status (return) code to be examined
   * @return <code>true</code> or <code>false</code>
   */
  public static boolean hasData(int code)
  {
    if (code == 0) return true;
    if (code < 0) return false;
    if ((code & CE_SENDDATA) == CE_SENDDATA) return true;
    return false;
  }
  public static boolean isLinkSuccess(int code)
  {
    if (code < 0) return false;
    if (code == 0) return true;
    if ((code & CE_SENDDATA) == CE_SENDDATA) return true;
    return false;
  }
  /**
   * Determines whether the given return code also implies that
   * data have been returned from a different source than that given 
   * in the call.
   * @param code is the return (error) code to be examined
   * @return <code>true</code> or <code>false</code>
   */
  public static boolean isRedirected(int code)
  {
    return (code & CE_REDIRECTED) == CE_REDIRECTED;
  }
  public static boolean isCoercive(int code)
  {
    switch (code)
    {
    	//case TErrorList.property_is_mca:
      case TErrorList.server_redirection:
      case TErrorList.has_structure_tag:
      case TErrorList.has_bitfield_tag:
      case TErrorList.mcast_access_required:
      case TErrorList.invalid_datarequest:
      case TErrorList.invalid_interval:
        return true;
      default:
        return false;
    }    
  }
}
