package de.desy.tine.stringUtils;

public class Str
{
  public static boolean isTrue(String s)
  {
    if (s == null) return false;
    if (s.compareToIgnoreCase("TRUE") == 0) return true;
    if (s.compareToIgnoreCase("YES") == 0) return true;
    if (s.compareToIgnoreCase("ON") == 0) return true;
    return false;
  }
  public static String getenv(String envKey)
  {
    if (envKey == null) return null;
    String lcEnvKey = envKey.toLowerCase();
    String ucEnvKey = envKey.toUpperCase();
    String env = null;
    if (lcEnvKey.contains("_"))
    { // given as environment variable: prepare system property:
      String[] pts = lcEnvKey.split("_");
      lcEnvKey = pts[0];
      for (int i=1; i<pts.length; i++) lcEnvKey += "."+pts[i];
    }
    if (ucEnvKey.contains("."))
    { // given as system property: prepare environment variable
      String[] pts = ucEnvKey.split("\\.");
      ucEnvKey = pts[0];
      for (int i=1; i<pts.length; i++) ucEnvKey += "_"+pts[i];
    }
    if ((env=System.getProperty(lcEnvKey)) != null) return env;
    return System.getenv(ucEnvKey);
  }
  public static boolean envIsTrue(String envKey)
  {
    return isTrue(getenv(envKey));
  }
  public static int atoi(String s)
  {
    if (s == null || s.length() == 0) return 0;
    int v = 0;
    try { v = Integer.parseInt(s); return v;} catch (Exception any) {};
    try { v = (int)Float.parseFloat(s); return v;} catch (Exception any) {};
    return v;
  }
}
